% Calculating the price the cruise ship can be sold for.

function Sell_calculation = Sell(i,Era,Era_generation,Ship_design)

% Reading from excel file to collecting the book values:
Design_1 = xlsread('Annuity_loan.xls','Annuity loan (Design 1)');
Design_2 = xlsread('Annuity_loan.xls','Annuity loan (Design 2)');
Design_3 = xlsread('Annuity_loan.xls','Annuity loan (Design 3)');

% Collecting the bookvalues.
Book_value_ship_1 = Design_1(45:50,15);
Book_value_ship_2 = Design_2(44:49,15);
Book_value_ship_3 = Design_3(44:49,15);

% The in-flexible ship is "punished" more than the flexible ones if a
% global regulation is introduced.
Value_reduction_1 = 1-0.7;
Value_reduction_2 = 1-0.5;
Value_reduction_3 = 1-0.5;

% Scrapping
LDT = 52000; %[Tonnes], Lightship weight of "Celebrity Edge" (baseline ship).
Scrap_price = 250; %[USD/LDT]
Scrap_value = LDT*Scrap_price;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
% Ship design 1 (Baseline cruise ship)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

    if Ship_design == 1
        if i == 1
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_1(1,1)*Value_reduction_1;  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_1(1,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 2 
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_1(2,1)*Value_reduction_1; 
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_1(2,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 3
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_1(3,1)*Value_reduction_1;   
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_1(3,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
            
        elseif i == 4
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_1(4,1)*Value_reduction_1;   
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_1(4,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 5
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_1(5,1)*Value_reduction_1;  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_1(5,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 6
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_1(6,1)*Value_reduction_1;   
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_1(6,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Ship design 2 (Dual fuel cruise ship design)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%         
        
    elseif Ship_design == 2
        if i == 1
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_2(1,1)*Value_reduction_2;  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_2(1,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 2 
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_2(2,1)*Value_reduction_2;
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_2(2,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 3
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_2(3,1)*Value_reduction_2;  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_2(3,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 4
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_2(4,1)*Value_reduction_2; 
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_2(4,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 5
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_2(5,1)*Value_reduction_2;
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_2(5,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 6
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_2(6,1)*Value_reduction_2;  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_2(6,1); 
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        end        

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Ship design 3 (Ammonia ready cruise ship design)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    elseif Ship_design == 3
        if i == 1
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_3(1,1)*Value_reduction_3;
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_3(1,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 2 
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_3(2,1)*Value_reduction_3;
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_3(2,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 3
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_3(3,1)*Value_reduction_3;  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_3(3,1);  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 4
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_3(4,1)*Value_reduction_3; 
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_3(4,1); 
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 5
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_3(5,1)*Value_reduction_3; 
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_3(5,1);
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        elseif i == 6
            % Global regulation:    
            if Era_generation(i,19,Era) == 1 || Era_generation(i,21,Era) == 1
                Sell_ship = Book_value_ship_3(6,1)*Value_reduction_3;  
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            % Local regulation:
            elseif Era_generation(i,18,Era) == 1 || Era_generation(i,20,Era) == 1
                Sell_ship = Book_value_ship_3(6,1); 
                if Sell_ship >= Scrap_value
                    Sell_calculation = Sell_ship;
                else
                    Sell_calculation = Scrap_value;
                end
            end
        end
    end
end



