% Calculating the cash flow, and discounting the cash flow to the NPV:

function CF = Cash_flow(a,Sim,Total_lifecycle, Operating_time, Build_time, t_loan_newbuild, d_r, Ship_matrix, Num_ship_design, Era_generation, ...
    Num_eras, Revenue_time_loss,Era)


%Prealocating space for the NPV for each design in each era
NPV_result_matrix = zeros(Num_eras,Num_ship_design);
NPV_result = zeros(1,Num_ship_design);

% Flexibility value
Flexibility_value_matrix = zeros(Num_eras,2);

% Prealocating space for the construction cost vector
Construction_cost_vector = zeros(1,Build_time);

% Prealocating space for the cash flow calculation
Cash_flow_vector = zeros(1,Operating_time);
CAPEX_vector = zeros(1,Operating_time);
OPEX_vector = zeros(1,Operating_time);
VOYEX_vector = zeros(1,Operating_time);
Revenue_vector = zeros(1,Operating_time);

% Cash flow vector "end":
Cash_flow_vector_end = zeros(1,Total_lifecycle);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Global zero emission regulations
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Prealocating space global zero emissions (also used when global zero emission regulations occur inside local zero emissions)
% For for global zero emission between Epoch 1->2
CAPEX_retrofit_12_globalreg_95 = zeros(1,Operating_time-5); 
OPEX_retrofit_12_globalreg_95 = zeros(1,Operating_time-5); 
VOYEX_retrofit_12_globalreg_95 = zeros(1,Operating_time-5); 
Revenue_retrofit_12_globalreg_95 = zeros(1,Operating_time-5);
CAPEX_retrofit_12_globalreg_100 = zeros(1,Operating_time-5); 
OPEX_retrofit_12_globalreg_100 = zeros(1,Operating_time-5); 
VOYEX_retrofit_12_globalreg_100 = zeros(1,Operating_time-5); 
Revenue_retrofit_12_globalreg_100 = zeros(1,Operating_time-5);
CAPEX_sell_12_globalreg = zeros(1,Operating_time-5);
OPEX_sell_12_globalreg = zeros(1,Operating_time-5);
VOYEX_sell_12_globalreg = zeros(1,Operating_time-5);
Revenue_sell_12_globalreg = zeros(1,Operating_time-5);
% For for global zero emission between Epoch 2->3
CAPEX_retrofit_23_globalreg_95 = zeros(1,Operating_time-10);
OPEX_retrofit_23_globalreg_95 = zeros(1,Operating_time-10);
VOYEX_retrofit_23_globalreg_95 = zeros(1,Operating_time-10);
Revenue_retrofit_23_globalreg_95 = zeros(1,Operating_time-10);
CAPEX_retrofit_23_globalreg_100 = zeros(1,Operating_time-10);
OPEX_retrofit_23_globalreg_100 = zeros(1,Operating_time-10);
VOYEX_retrofit_23_globalreg_100 = zeros(1,Operating_time-10);
Revenue_retrofit_23_globalreg_100 = zeros(1,Operating_time-10);
CAPEX_sell_23_globalreg = zeros(1,Operating_time-10);
OPEX_sell_23_globalreg = zeros(1,Operating_time-10);
VOYEX_sell_23_globalreg = zeros(1,Operating_time-10);
Revenue_sell_23_globalreg = zeros(1,Operating_time-10);
% For for global zero emission between Epoch 3->4
CAPEX_retrofit_34_globalreg_95 = zeros(1,Operating_time-15);
OPEX_retrofit_34_globalreg_95 = zeros(1,Operating_time-15);
VOYEX_retrofit_34_globalreg_95 = zeros(1,Operating_time-15);
Revenue_retrofit_34_globalreg_95 = zeros(1,Operating_time-15);
CAPEX_retrofit_34_globalreg_100 = zeros(1,Operating_time-15);
OPEX_retrofit_34_globalreg_100 = zeros(1,Operating_time-15);
VOYEX_retrofit_34_globalreg_100 = zeros(1,Operating_time-15);
Revenue_retrofit_34_globalreg_100 = zeros(1,Operating_time-15);
CAPEX_sell_34_globalreg = zeros(1,Operating_time-15);
OPEX_sell_34_globalreg = zeros(1,Operating_time-15);
VOYEX_sell_34_globalreg = zeros(1,Operating_time-15);
Revenue_sell_34_globalreg = zeros(1,Operating_time-15); 
% For for global zero emission between Epoch 4->5
CAPEX_retrofit_45_globalreg_95 = zeros(1,Operating_time-20);
OPEX_retrofit_45_globalreg_95 = zeros(1,Operating_time-20);
VOYEX_retrofit_45_globalreg_95 = zeros(1,Operating_time-20);
Revenue_retrofit_45_globalreg_95 = zeros(1,Operating_time-20);
CAPEX_retrofit_45_globalreg_100 = zeros(1,Operating_time-20);
OPEX_retrofit_45_globalreg_100 = zeros(1,Operating_time-20);
VOYEX_retrofit_45_globalreg_100 = zeros(1,Operating_time-20);
Revenue_retrofit_45_globalreg_100 = zeros(1,Operating_time-20);
CAPEX_sell_45_globalreg = zeros(1,Operating_time-20);
OPEX_sell_45_globalreg = zeros(1,Operating_time-20);
VOYEX_sell_45_globalreg = zeros(1,Operating_time-20);
Revenue_sell_45_globalreg = zeros(1,Operating_time-20);
% For for global zero emission between Epoch 5->6
CAPEX_retrofit_56_globalreg_95 = zeros(1,Operating_time-25);
OPEX_retrofit_56_globalreg_95 = zeros(1,Operating_time-25);
VOYEX_retrofit_56_globalreg_95 = zeros(1,Operating_time-25);
Revenue_retrofit_56_globalreg_95 = zeros(1,Operating_time-25);
CAPEX_retrofit_56_globalreg_100 = zeros(1,Operating_time-25);
OPEX_retrofit_56_globalreg_100 = zeros(1,Operating_time-25);
VOYEX_retrofit_56_globalreg_100 = zeros(1,Operating_time-25);
Revenue_retrofit_56_globalreg_100 = zeros(1,Operating_time-25);
CAPEX_sell_56_globalreg = zeros(1,Operating_time-25);
OPEX_sell_56_globalreg = zeros(1,Operating_time-25);
VOYEX_sell_56_globalreg = zeros(1,Operating_time-25);
Revenue_sell_56_globalreg = zeros(1,Operating_time-25);

% Global regulations:
%Prealocating for cash flow vectors:
% % For for global zero emission between Epoch 1->2 
CF_retrofit_12_globalreg_95 = zeros(1,Operating_time-5);
CF_retrofit_12_globalreg_100 = zeros(1,Operating_time-5);
CF_sell_12_globalreg = zeros(1,Operating_time-5); 
% % For for global zero emission between Epoch 2->3
CF_retrofit_23_globalreg_95 = zeros(1,Operating_time-10);
CF_retrofit_23_globalreg_100 = zeros(1,Operating_time-10);
CF_sell_23_globalreg = zeros(1,Operating_time-10); 
% For for global zero emission between Epoch 3->4
CF_retrofit_34_globalreg_95 = zeros(1,Operating_time-15);
CF_retrofit_34_globalreg_100 = zeros(1,Operating_time-15);
CF_sell_34_globalreg = zeros(1,Operating_time-15); 
% For for global zero emission between Epoch 4->5
CF_retrofit_45_globalreg_95 = zeros(1,Operating_time-20);
CF_retrofit_45_globalreg_100 = zeros(1,Operating_time-20);
CF_sell_45_globalreg = zeros(1,Operating_time-20); 
% For for global zero emission between Epoch 5->6 
CF_retrofit_56_globalreg_95 = zeros(1,Operating_time-25);
CF_retrofit_56_globalreg_100 = zeros(1,Operating_time-25);
CF_sell_56_globalreg = zeros(1,Operating_time-25);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Local zero emission regulations
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Prealocating space for local regulations:
% Local regulation between epoch 1 -> 2:
CAPEX_retrofit_12_localreg_95 = zeros(1,Operating_time-5); 
OPEX_retrofit_12_localreg_95 = zeros(1,Operating_time-5);
VOYEX_retrofit_12_localreg_95 = zeros(1,Operating_time-5);
Revenue_retrofit_12_localreg_95 = zeros(1,Operating_time-5);
CAPEX_retrofit_12_localreg_100 = zeros(1,Operating_time-5); 
OPEX_retrofit_12_localreg_100 = zeros(1,Operating_time-5);
VOYEX_retrofit_12_localreg_100 = zeros(1,Operating_time-5);
Revenue_retrofit_12_localreg_100 = zeros(1,Operating_time-5);
CAPEX_sail_another_route_12_localreg = zeros(1,Operating_time-5);
OPEX_sail_another_route_12_localreg = zeros(1,Operating_time-5); 
VOYEX_sail_another_route_12_localreg = zeros(1,Operating_time-5); 
Revenue_sail_another_route_12_localreg = zeros(1,Operating_time-5); 
CAPEX_sell_12_localreg = zeros(1,Operating_time-5);
OPEX_sell_12_localreg = zeros(1,Operating_time-5); 
VOYEX_sell_12_localreg = zeros(1,Operating_time-5); 
Revenue_sell_12_localreg = zeros(1,Operating_time-5);
% Local regulation between epoch 2 -> 3:
CAPEX_retrofit_23_localreg_95 = zeros(1,Operating_time-10); 
OPEX_retrofit_23_localreg_95 = zeros(1,Operating_time-10);
VOYEX_retrofit_23_localreg_95 = zeros(1,Operating_time-10);
Revenue_retrofit_23_localreg_95 = zeros(1,Operating_time-10);
CAPEX_retrofit_23_localreg_100 = zeros(1,Operating_time-10); 
OPEX_retrofit_23_localreg_100 = zeros(1,Operating_time-10);
VOYEX_retrofit_23_localreg_100 = zeros(1,Operating_time-10);
Revenue_retrofit_23_localreg_100 = zeros(1,Operating_time-10);
CAPEX_sail_another_route_23_localreg = zeros(1,Operating_time-10);
OPEX_sail_another_route_23_localreg = zeros(1,Operating_time-10); 
VOYEX_sail_another_route_23_localreg = zeros(1,Operating_time-10); 
Revenue_sail_another_route_23_localreg = zeros(1,Operating_time-10); 
CAPEX_sell_23_localreg = zeros(1,Operating_time-10);
OPEX_sell_23_localreg = zeros(1,Operating_time-10); 
VOYEX_sell_23_localreg = zeros(1,Operating_time-10); 
Revenue_sell_23_localreg = zeros(1,Operating_time-10);
% Local regulation between epoch 3 -> 4:
CAPEX_retrofit_34_localreg_95 = zeros(1,Operating_time-15); 
OPEX_retrofit_34_localreg_95 = zeros(1,Operating_time-15);
VOYEX_retrofit_34_localreg_95 = zeros(1,Operating_time-15);
Revenue_retrofit_34_localreg_95 = zeros(1,Operating_time-15);
CAPEX_retrofit_34_localreg_100 = zeros(1,Operating_time-15); 
OPEX_retrofit_34_localreg_100 = zeros(1,Operating_time-15);
VOYEX_retrofit_34_localreg_100 = zeros(1,Operating_time-15);
Revenue_retrofit_34_localreg_100 = zeros(1,Operating_time-15);
CAPEX_sail_another_route_34_localreg = zeros(1,Operating_time-15);
OPEX_sail_another_route_34_localreg = zeros(1,Operating_time-15); 
VOYEX_sail_another_route_34_localreg = zeros(1,Operating_time-15); 
Revenue_sail_another_route_34_localreg = zeros(1,Operating_time-15); 
CAPEX_sell_34_localreg = zeros(1,Operating_time-15);
OPEX_sell_34_localreg = zeros(1,Operating_time-15); 
VOYEX_sell_34_localreg = zeros(1,Operating_time-15); 
Revenue_sell_34_localreg = zeros(1,Operating_time-15);
% Local regulation between epoch 4 -> 5:
CAPEX_retrofit_45_localreg_95 = zeros(1,Operating_time-20); 
OPEX_retrofit_45_localreg_95 = zeros(1,Operating_time-20);
VOYEX_retrofit_45_localreg_95 = zeros(1,Operating_time-20);
Revenue_retrofit_45_localreg_95 = zeros(1,Operating_time-20);
CAPEX_retrofit_45_localreg_100 = zeros(1,Operating_time-20); 
OPEX_retrofit_45_localreg_100 = zeros(1,Operating_time-20);
VOYEX_retrofit_45_localreg_100 = zeros(1,Operating_time-20);
Revenue_retrofit_45_localreg_100 = zeros(1,Operating_time-20);
CAPEX_sail_another_route_45_localreg = zeros(1,Operating_time-20);
OPEX_sail_another_route_45_localreg = zeros(1,Operating_time-20); 
VOYEX_sail_another_route_45_localreg = zeros(1,Operating_time-20); 
Revenue_sail_another_route_45_localreg = zeros(1,Operating_time-20); 
CAPEX_sell_45_localreg = zeros(1,Operating_time-20);
OPEX_sell_45_localreg = zeros(1,Operating_time-20); 
VOYEX_sell_45_localreg = zeros(1,Operating_time-20); 
Revenue_sell_45_localreg = zeros(1,Operating_time-20);
% Local regulation between epoch 5 -> 6:
CAPEX_retrofit_56_localreg_95 = zeros(1,Operating_time-25); 
OPEX_retrofit_56_localreg_95 = zeros(1,Operating_time-25);
VOYEX_retrofit_56_localreg_95 = zeros(1,Operating_time-25);
Revenue_retrofit_56_localreg_95 = zeros(1,Operating_time-25);
CAPEX_retrofit_56_localreg_100 = zeros(1,Operating_time-25); 
OPEX_retrofit_56_localreg_100 = zeros(1,Operating_time-25);
VOYEX_retrofit_56_localreg_100 = zeros(1,Operating_time-25);
Revenue_retrofit_56_localreg_100 = zeros(1,Operating_time-25);
CAPEX_sail_another_route_56_localreg = zeros(1,Operating_time-25);
OPEX_sail_another_route_56_localreg = zeros(1,Operating_time-25); 
VOYEX_sail_another_route_56_localreg = zeros(1,Operating_time-25); 
Revenue_sail_another_route_56_localreg = zeros(1,Operating_time-25); 
CAPEX_sell_56_localreg = zeros(1,Operating_time-25);
OPEX_sell_56_localreg = zeros(1,Operating_time-25); 
VOYEX_sell_56_localreg = zeros(1,Operating_time-25); 
Revenue_sell_56_localreg = zeros(1,Operating_time-25);

% Prealocating for space for local zero emission regulations:
% For local zero emission introduced between epoch 1->2  
CF_retrofit_12_localreg_95 = zeros(1,Operating_time-5);
CF_retrofit_12_localreg_100 = zeros(1,Operating_time-5);
CF_sail_another_route_12_localreg = zeros(1,Operating_time-5);
CF_sell_12_localreg = zeros(1,Operating_time-5);
% For local zero emission introduced between epoch 2->3
CF_retrofit_23_localreg_95 = zeros(1,Operating_time-10);
CF_retrofit_23_localreg_100 = zeros(1,Operating_time-10);
CF_sail_another_route_23_localreg = zeros(1,Operating_time-10);
CF_sell_23_localreg = zeros(1,Operating_time-10);
% For local zero emission introduced between epoch 3->4
CF_retrofit_34_localreg_95 = zeros(1,Operating_time-15);
CF_retrofit_34_localreg_100 = zeros(1,Operating_time-15);
CF_sail_another_route_34_localreg = zeros(1,Operating_time-15);
CF_sell_34_localreg = zeros(1,Operating_time-15);
% For local zero emission introduced between epoch 4->5
CF_retrofit_45_localreg_95 = zeros(1,Operating_time-20);
CF_retrofit_45_localreg_100 = zeros(1,Operating_time-20);
CF_sail_another_route_45_localreg = zeros(1,Operating_time-20);
CF_sell_45_localreg = zeros(1,Operating_time-20);
% For local zero emission introduced between epoch 5->6
CF_retrofit_56_localreg_95 = zeros(1,Operating_time-25);
CF_retrofit_56_localreg_100 = zeros(1,Operating_time-25);
CF_sail_another_route_56_localreg = zeros(1,Operating_time-25);
CF_sell_56_localreg = zeros(1,Operating_time-25);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Global zero emission regulations inside local zero emission regulations:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% NOTE: Using the same prealocated vectors here as for the case where
% global zero emission regulations occure before local zero emission
% regulations. 

% Global regulation in local regulation:
% Between epoch 1 -> 2.
CF_sail_another_route_localreg_12_globalreg_23 = zeros(1,Operating_time-5);
CF_sail_another_route_localreg_12_globalreg_34 = zeros(1,Operating_time-5);
CF_sail_another_route_localreg_12_globalreg_45 = zeros(1,Operating_time-5);
CF_sail_another_route_localreg_12_globalreg_56 = zeros(1,Operating_time-5);
% Between epoch 2 -> 3.
CF_sail_another_route_localreg_23_globalreg_34 = zeros(1,Operating_time-10);
CF_sail_another_route_localreg_23_globalreg_45 = zeros(1,Operating_time-10);
CF_sail_another_route_localreg_23_globalreg_56 = zeros(1,Operating_time-10);
% Between epoch 3 -> 4.
CF_sail_another_route_localreg_34_globalreg_45 = zeros(1,Operating_time-15);
CF_sail_another_route_localreg_34_globalreg_56 = zeros(1,Operating_time-15);
% Between epoch 4 -> 5.
CF_sail_another_route_localreg_45_globalreg_56 = zeros(1,Operating_time-20);
% Between epoch 5 -> 6.
% Non

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Optional retrofits (Retrofits not because of regulations)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Optional retrofits: 
% Optional retrofit between epoch 2 -> 3.
CAPEX_retrofit_23_optional_95 = zeros(1,Operating_time-10);
OPEX_retrofit_23_optional_95 = zeros(1,Operating_time-10);
VOYEX_retrofit_23_optional_95 = zeros(1,Operating_time-10);
Revenue_retrofit_23_optional_95 = zeros(1,Operating_time-10);
CAPEX_retrofit_23_optional_100 = zeros(1,Operating_time-10);
OPEX_retrofit_23_optional_100 = zeros(1,Operating_time-10);
VOYEX_retrofit_23_optional_100 = zeros(1,Operating_time-10);
Revenue_retrofit_23_optional_100 = zeros(1,Operating_time-10);
% Optional retrofit between epoch 3 -> 4.
CAPEX_retrofit_34_optional_95 = zeros(1,Operating_time-15);
OPEX_retrofit_34_optional_95 = zeros(1,Operating_time-15);
VOYEX_retrofit_34_optional_95 = zeros(1,Operating_time-15);
Revenue_retrofit_34_optional_95 = zeros(1,Operating_time-15);
CAPEX_retrofit_34_optional_100 = zeros(1,Operating_time-15);
OPEX_retrofit_34_optional_100 = zeros(1,Operating_time-15);
VOYEX_retrofit_34_optional_100 = zeros(1,Operating_time-15);
Revenue_retrofit_34_optional_100 = zeros(1,Operating_time-15);
% Optional retrofit between epoch 4 -> 5.
CAPEX_retrofit_45_optional_95 = zeros(1,Operating_time-20);
OPEX_retrofit_45_optional_95 = zeros(1,Operating_time-20);
VOYEX_retrofit_45_optional_95 = zeros(1,Operating_time-20);
Revenue_retrofit_45_optional_95 = zeros(1,Operating_time-20);
CAPEX_retrofit_45_optional_100 = zeros(1,Operating_time-20);
OPEX_retrofit_45_optional_100 = zeros(1,Operating_time-20);
VOYEX_retrofit_45_optional_100 = zeros(1,Operating_time-20);
Revenue_retrofit_45_optional_100 = zeros(1,Operating_time-20);
% Optional retrofit between epoch 5 -> 6.
CAPEX_retrofit_56_optional_95 = zeros(1,Operating_time-25);
OPEX_retrofit_56_optional_95 = zeros(1,Operating_time-25);
VOYEX_retrofit_56_optional_95 = zeros(1,Operating_time-25);
Revenue_retrofit_56_optional_95 = zeros(1,Operating_time-25);
CAPEX_retrofit_56_optional_100 = zeros(1,Operating_time-25);
OPEX_retrofit_56_optional_100 = zeros(1,Operating_time-25);
VOYEX_retrofit_56_optional_100 = zeros(1,Operating_time-25);
Revenue_retrofit_56_optional_100 = zeros(1,Operating_time-25);

% Prealocating space for optional retrofit:
CF_optional_23_95 = zeros(1,Operating_time-10);
CF_optional_23_100 = zeros(1,Operating_time-10);
CF_optional_34_95 = zeros(1,Operating_time-15);
CF_optional_34_100 = zeros(1,Operating_time-15);
CF_optional_45_95 = zeros(1,Operating_time-20);
CF_optional_45_100 = zeros(1,Operating_time-20);
CF_optional_56_95 = zeros(1,Operating_time-25);
CF_optional_56_100 = zeros(1,Operating_time-25);

% Prealocating space for the cash flow vectors for optional retrofitting. 
CF_retrofit_23_optional = zeros(1,Operating_time-5);
CF_retrofit_34_optional = zeros(1,Operating_time-5);
CF_retrofit_45_optional = zeros(1,Operating_time-5);
CF_retrofit_56_optional = zeros(1,Operating_time-5);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% NPV results
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    Ship_design = Ship_matrix(1,a);
    CAPEX_newbuild = Ship_matrix(2,a);
    CAPEX_retrofit_ammonia = Ship_matrix(3,a);
    CAPEX_retrofit_hydrogen = Ship_matrix(4,a);
    Retrofit = Ship_matrix(5,a); %Initially=0
    Shipyard = Ship_matrix(6,a); %Initially=0
    Hydrogen = Ship_matrix(7,a); %Initially=0
    
    % Calculating the bulding cost
    for Build_year = 1:Build_time
        Construction_cost_vector(Build_year) = -CAPEX_newbuild/Build_time;
    end    

% This has no influence on the calculatio:
Stochastic_fuel_price = 1;

% Generating stochastic fuel price for each week within each epoch for each
% fuel:
Stochastic_fuel_price_weekly = Epoch_weekly_stochastic_fuel_prices(Era,Era_generation);

% Set a flag to jump out of the for-loop
finishNow = false;

% Not go into a global regulation condition if it already have been into
% one: 
Global_regulation = 0;

for i = 1:6 %"Num_epochs_in_era", Number of epochs in an era
   for j = 1:5 %Number of years in each epoch
         
        % Normal operation of the cruise ship
        CAPEX_vector(j+((i-1)*5)) = CAPEX(i,j,Ship_design); 
        OPEX_vector(j+((i-1)*5)) = OPEX(i,j,Ship_design,Retrofit,Hydrogen);
        VOYEX_vector(j+((i-1)*5)) = VOYEX(i,j,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
        Revenue_vector(j+((i-1)*5)) = Revenue(i,j,Retrofit,Ship_design,Shipyard); 

        % Check for global zero-emission regulation
        % Check if global zero-emission regulation occurs between epoch
        % 1-2.
        
        if (Era_generation(i,19,Era) == 1 && i == 2 && j == 1) || (Era_generation(i,21,Era) == 1 && i == 2 && j == 1)
            
            for k = 2:6
                for l = 1:5
            
                    % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!) 
                    if Era_generation(k,19,Era) == 1 && k == 2 && l == 1
                        Retrofit = 1;
                        Shipyard = 1;
                        CAPEX_retrofit_12_globalreg_95(l+((k-2)*5)) = CAPEX_retrofit_ammonia + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_12_globalreg_95(l+((k-2)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_12_globalreg_95(l+((k-2)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_12_globalreg_95(l+((k-2)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    elseif Era_generation(k,19,Era) == 1
                        Retrofit = 1;
                        CAPEX_retrofit_12_globalreg_95(l+((k-2)*5)) = CAPEX(k,l,Ship_design);
                        OPEX_retrofit_12_globalreg_95(l+((k-2)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_12_globalreg_95(l+((k-2)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                        Revenue_retrofit_12_globalreg_95(l+((k-2)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    
                    % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                    if k == 2 && l == 1  
                        Retrofit = 2;
                        Shipyard = 1;
                        CAPEX_retrofit_12_globalreg_100(l+((k-2)*5)) = CAPEX_retrofit_hydrogen + CAPEX(k,l,Ship_design);
                        OPEX_retrofit_12_globalreg_100(l+((k-2)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_12_globalreg_100(l+((k-2)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                        Revenue_retrofit_12_globalreg_100(l+((k-2)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    else
                        Retrofit = 2;
                        Hydrogen = 1;
                        CAPEX_retrofit_12_globalreg_100(l+((k-2)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_12_globalreg_100(l+((k-2)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_12_globalreg_100(l+((k-2)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                        Revenue_retrofit_12_globalreg_100(l+((k-2)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    

                    % Sell option: 
                    if k == 2 && l == 1
                        Retrofit = 0;
                        CAPEX_sell_12_globalreg(l+((k-2)*5)) = 0;
                        OPEX_sell_12_globalreg(l+((k-2)*5)) = 0;
                        VOYEX_sell_12_globalreg(l+((k-2)*5)) = 0;
                        Revenue_sell_12_globalreg(l+((k-2)*5)) = Sell(k,Era,Era_generation,Ship_design) - Loan_balance(k,l,Ship_design);
                    else
                        Retrofit = 0;
                        CAPEX_sell_12_globalreg(l+((k-2)*5)) = 0;
                        OPEX_sell_12_globalreg(l+((k-2)*5)) = 0;
                        VOYEX_sell_12_globalreg(l+((k-2)*5)) = 0;
                        Revenue_sell_12_globalreg(l+((k-2)*5)) = 0;    
                    end
            
                    CF_retrofit_12_globalreg_95(l+((k-2)*5)) = Revenue_retrofit_12_globalreg_95(l+((k-2)*5)) - ...
                        CAPEX_retrofit_12_globalreg_95(l+((k-2)*5)) - OPEX_retrofit_12_globalreg_95(l+((k-2)*5)) - VOYEX_retrofit_12_globalreg_95(l+((k-2)*5));
                    
                    CF_retrofit_12_globalreg_100(l+((k-2)*5)) = Revenue_retrofit_12_globalreg_100(l+((k-2)*5)) - ...
                        CAPEX_retrofit_12_globalreg_100(l+((k-2)*5)) - OPEX_retrofit_12_globalreg_100(l+((k-2)*5)) - VOYEX_retrofit_12_globalreg_100(l+((k-2)*5));
            
                    CF_sell_12_globalreg(l+((k-2)*5)) = Revenue_sell_12_globalreg(l+((k-2)*5)) - ...
                        CAPEX_sell_12_globalreg(l+((k-2)*5)) - OPEX_sell_12_globalreg(l+((k-2)*5)) - VOYEX_sell_12_globalreg(l+((k-2)*5));
            
                end
            end
            
            NPV_retrofit_12_globalreg_95 = NPV(CF_retrofit_12_globalreg_95,d_r,25);
            NPV_retrofit_12_globalreg_100 = NPV(CF_retrofit_12_globalreg_100,d_r,25);
            NPV_sell_12_globalreg = NPV(CF_sell_12_globalreg,d_r,25);
            
            if NPV_retrofit_12_globalreg_95 >= NPV_sell_12_globalreg && NPV_retrofit_12_globalreg_95 >= NPV_retrofit_12_globalreg_100
                
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_retrofit_12_globalreg_95];
                
            elseif NPV_retrofit_12_globalreg_100 >= NPV_sell_12_globalreg && NPV_retrofit_12_globalreg_100 >= NPV_retrofit_12_globalreg_95
                
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_retrofit_12_globalreg_100];     
                
            elseif NPV_sell_12_globalreg >= NPV_retrofit_12_globalreg_95 && NPV_sell_12_globalreg >= NPV_retrofit_12_globalreg_100
  
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_sell_12_globalreg];
            
            end
            finishNow = true;
        end
        % Terminates the inner for-loop
        if finishNow 
        break
        end
    
    
    % Terminates the outer for-loop
    if finishNow
    break
    end
        
        % Check if local zero-emission regulation occurs between epoch
        % 1-2.
        
        if (Era_generation(i,18,Era) == 1 && i == 2 && j == 1) || (Era_generation(i,20,Era) == 1 && i == 2 && j == 1)
            
           for k = 2:6
                for l = 1:5
            
                    % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future 95% zero emission zones also!)
                    if Era_generation(i,18,Era) == 1 && k == 2 && l == 1
                        Retrofit = 1;
                        Shipyard = 1;
                        CAPEX_retrofit_12_localreg_95(l+((k-2)*5)) = CAPEX_retrofit_ammonia + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_12_localreg_95(l+((k-2)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_12_localreg_95(l+((k-2)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_12_localreg_95(l+((k-2)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    elseif Era_generation(i,18,Era) == 1
                        Retrofit = 1;
                        CAPEX_retrofit_12_localreg_95(l+((k-2)*5)) = CAPEX(k,l,Ship_design);
                        OPEX_retrofit_12_localreg_95(l+((k-2)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_12_localreg_95(l+((k-2)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                        Revenue_retrofit_12_localreg_95(l+((k-2)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);    
                    end

                    % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future 100% zero emission zones also!)
                    % Construction year:
                    if k == 2 && l == 1  
                        Retrofit = 2;
                        Shipyard = 1;
                        CAPEX_retrofit_12_localreg_100(l+((k-2)*5)) = CAPEX_retrofit_hydrogen + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_12_localreg_100(l+((k-2)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_12_localreg_100(l+((k-2)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                        Revenue_retrofit_12_localreg_100(l+((k-2)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    else
                        Retrofit = 2;
                        Hydrogen = 1;
                        CAPEX_retrofit_12_localreg_100(l+((k-2)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_12_localreg_100(l+((k-2)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_12_localreg_100(l+((k-2)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                        Revenue_retrofit_12_localreg_100(l+((k-2)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    
                    % Sail another route option:
                    % Calculate for epoch 2,3,4,5,6 (depending on "global zero-emission" is introduced or not) 
                    Retrofit = 0;
                    CAPEX_sail_another_route_12_localreg(l+((k-2)*5)) = CAPEX(k,l,Ship_design); 
                    OPEX_sail_another_route_12_localreg(l+((k-2)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                    VOYEX_sail_another_route_12_localreg(l+((k-2)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                    Revenue_sail_another_route_12_localreg(l+((k-2)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard) - (Revenue(k,l,Retrofit,Ship_design,Shipyard)*Revenue_time_loss); % loss in revenue 
                    
                       % Need to check if a global regulation is introduced between epoch 2-3.
                       if (Era_generation(k,19,Era) == 1 && k == 3 && l == 1 && Global_regulation == 0) || (Era_generation(k,21,Era) == 1 && k == 3 && l == 1 && Global_regulation == 0)
                            
                           for m = 3:6
                                for n = 1:5
                                
                                % Have to either retrofit or sell!    
                                
                                % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                % Construction year:
                                if Era_generation(m,19,Era) == 1 && m == 3 && n == 1
                                    Retrofit = 1;
                                    Shipyard = 1;
                                    CAPEX_retrofit_23_globalreg_95(n+((m-3)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_23_globalreg_95(n+((m-3)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_23_globalreg_95(n+((m-3)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                    Revenue_retrofit_23_globalreg_95(n+((m-3)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                elseif Era_generation(m,19,Era) == 1 
                                    Retrofit = 1;
                                    CAPEX_retrofit_23_globalreg_95(n+((m-3)*5)) = CAPEX(m,n,Ship_design);
                                    OPEX_retrofit_23_globalreg_95(n+((m-3)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_23_globalreg_95(n+((m-3)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                    Revenue_retrofit_23_globalreg_95(n+((m-3)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end

                                % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                % Construction year:
                                if m == 3 && n == 1  
                                    Retrofit = 2;
                                    Shipyard = 1;
                                    CAPEX_retrofit_23_globalreg_100(n+((m-3)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_23_globalreg_100(n+((m-3)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_23_globalreg_100(n+((m-3)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_23_globalreg_100(n+((m-3)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                else
                                    Retrofit = 2;
                                    Hydrogen = 1;
                                    CAPEX_retrofit_23_globalreg_100(n+((m-3)*5)) = CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_23_globalreg_100(n+((m-3)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_23_globalreg_100(n+((m-3)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                    Revenue_retrofit_23_globalreg_100(n+((m-3)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end

                                % Sell option: 
                                if m == 3 && n == 1
                                    Retrofit = 0;
                                    CAPEX_sell_23_globalreg(n+((m-3)*5)) = 0; 
                                    OPEX_sell_23_globalreg(n+((m-3)*5)) = 0;
                                    VOYEX_sell_23_globalreg(n+((m-3)*5)) = 0;
                                    Revenue_sell_23_globalreg(n+((m-3)*5)) = Sell(m,Era,Era_generation,Ship_design) - Loan_balance(m,n,Ship_design);
                                else
                                    Retrofit = 0;
                                    CAPEX_sell_23_globalreg(n+((m-3)*5)) = 0; 
                                    OPEX_sell_23_globalreg(n+((m-3)*5)) = 0;
                                    VOYEX_sell_23_globalreg(n+((m-3)*5)) = 0;
                                    Revenue_sell_23_globalreg(n+((m-3)*5)) = 0;    
                                end
            
                                CF_retrofit_23_globalreg_95(n+((m-3)*5)) = Revenue_retrofit_23_globalreg_95(n+((m-3)*5)) - ...
                                    CAPEX_retrofit_23_globalreg_95(n+((m-3)*5)) - OPEX_retrofit_23_globalreg_95(n+((m-3)*5)) - VOYEX_retrofit_23_globalreg_95(n+((m-3)*5));
                                
                                CF_retrofit_23_globalreg_100(n+((m-3)*5)) = Revenue_retrofit_23_globalreg_100(n+((m-3)*5)) - ...
                                    CAPEX_retrofit_23_globalreg_100(n+((m-3)*5)) - OPEX_retrofit_23_globalreg_100(n+((m-3)*5)) - VOYEX_retrofit_23_globalreg_100(n+((m-3)*5));
            
                                CF_sell_23_globalreg(n+((m-3)*5)) = Revenue_sell_23_globalreg(n+((m-3)*5)) - ...
                                    CAPEX_sell_23_globalreg(n+((m-3)*5)) - OPEX_sell_23_globalreg(n+((m-3)*5)) - VOYEX_sell_23_globalreg(n+((m-3)*5));
            
                                end
                           end
            
                           NPV_retrofit_23_globalreg_95 = NPV(CF_retrofit_23_globalreg_95,d_r,20);
                           NPV_retrofit_23_globalreg_100 = NPV(CF_retrofit_23_globalreg_100,d_r,20);
                           NPV_sell_23_globalreg = NPV(CF_sell_23_globalreg,d_r,20);
            
                           if NPV_retrofit_23_globalreg_95 >= NPV_sell_23_globalreg && NPV_retrofit_23_globalreg_95 >= NPV_retrofit_23_globalreg_100

                                CF_sail_another_route_localreg_12_globalreg_23 = [CF_sail_another_route_12_localreg(1,(1:5)) CF_retrofit_23_globalreg_95];
                                
                                Ammonia_retrofit = 1;
                                
                           elseif NPV_retrofit_23_globalreg_100 >= NPV_sell_23_globalreg && NPV_retrofit_23_globalreg_100 >= NPV_retrofit_23_globalreg_95

                                CF_sail_another_route_localreg_12_globalreg_23 = [CF_sail_another_route_12_localreg(1,(1:5)) CF_retrofit_23_globalreg_100];
                
                            elseif NPV_sell_23_globalreg >= NPV_retrofit_23_globalreg_95 && NPV_sell_23_globalreg >= NPV_retrofit_23_globalreg_100
            
                                CF_sail_another_route_localreg_12_globalreg_23 = [CF_sail_another_route_12_localreg(1,(1:5)) CF_sell_23_globalreg];
                           end
                           Global_regulation = 1; 
                       end
                    
                    
                      % Need to check if a global regulation is introduced between epoch 3-4.
                       if (Era_generation(k,19,Era) == 1 && k == 4 && l == 1 && Global_regulation == 0) || (Era_generation(k,21,Era) == 1 && k == 4 && l == 1 && Global_regulation == 0)
                            
                           for m = 4:6
                                for n = 1:5
                                
                                % Have to either retrofit or sell!    
                                
                                % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                % Construction year:
                                if Era_generation(m,19,Era) == 1 && m == 4 && n == 1   
                                    Retrofit = 1;
                                    Shipyard = 1;
                                    CAPEX_retrofit_34_globalreg_95(n+((m-4)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_34_globalreg_95(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_34_globalreg_95(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                    Revenue_retrofit_34_globalreg_95(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                elseif Era_generation(m,19,Era) == 1   
                                    Retrofit = 1;
                                    CAPEX_retrofit_34_globalreg_95(n+((m-4)*5)) = CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_34_globalreg_95(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_34_globalreg_95(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_34_globalreg_95(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end
                                
                                % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                % Construction year:
                                if m == 4 && n == 1  
                                    Retrofit = 2;
                                    Shipyard = 1;
                                    CAPEX_retrofit_34_globalreg_100(n+((m-4)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_34_globalreg_100(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_34_globalreg_100(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_34_globalreg_100(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                else
                                    Retrofit = 2;
                                    Hydrogen = 1;
                                    CAPEX_retrofit_34_globalreg_100(n+((m-4)*5)) = CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_34_globalreg_100(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_34_globalreg_100(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                    Revenue_retrofit_34_globalreg_100(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end

                                % Sell option: 
                                if m == 4 && n == 1
                                    Retrofit = 0;
                                    CAPEX_sell_34_globalreg(n+((m-4)*5)) = 0; 
                                    OPEX_sell_34_globalreg(n+((m-4)*5)) = 0;
                                    VOYEX_sell_34_globalreg(n+((m-4)*5)) = 0;
                                    Revenue_sell_34_globalreg(n+((m-4)*5)) = Sell(m,Era,Era_generation,Ship_design) - Loan_balance(m,n,Ship_design);
                                else
                                    Retrofit = 0;
                                    CAPEX_sell_34_globalreg(n+((m-4)*5)) = 0; 
                                    OPEX_sell_34_globalreg(n+((m-4)*5)) = 0;
                                    VOYEX_sell_34_globalreg(n+((m-4)*5)) = 0;
                                    Revenue_sell_34_globalreg(n+((m-4)*5)) = 0;    
                                end
            
                                CF_retrofit_34_globalreg_95(n+((m-4)*5)) = Revenue_retrofit_34_globalreg_95(n+((m-4)*5)) - ...
                                    CAPEX_retrofit_34_globalreg_95(n+((m-4)*5)) - OPEX_retrofit_34_globalreg_95(n+((m-4)*5)) - VOYEX_retrofit_34_globalreg_95(n+((m-4)*5));
                                
                                CF_retrofit_34_globalreg_100(n+((m-4)*5)) = Revenue_retrofit_34_globalreg_100(n+((m-4)*5)) - ...
                                    CAPEX_retrofit_34_globalreg_100(n+((m-4)*5)) - OPEX_retrofit_34_globalreg_100(n+((m-4)*5)) - VOYEX_retrofit_34_globalreg_100(n+((m-4)*5));
                                
                                CF_sell_34_globalreg(n+((m-4)*5)) = Revenue_sell_34_globalreg(n+((m-4)*5)) - ...
                                    CAPEX_sell_34_globalreg(n+((m-4)*5)) - OPEX_sell_34_globalreg(n+((m-4)*5)) - VOYEX_sell_34_globalreg(n+((m-4)*5));
            
                                end
                           end
            
                           NPV_retrofit_34_globalreg_95 = NPV(CF_retrofit_34_globalreg_95,d_r,15);
                           NPV_retrofit_34_globalreg_100 = NPV(CF_retrofit_34_globalreg_100,d_r,15);
                           NPV_sell_34_globalreg = NPV(CF_sell_34_globalreg,d_r,15);
            
                           if NPV_retrofit_34_globalreg_95 >= NPV_sell_34_globalreg && NPV_retrofit_34_globalreg_95 >= NPV_retrofit_34_globalreg_100
                
                                CF_sail_another_route_localreg_12_globalreg_34 = [CF_sail_another_route_12_localreg(1,(1:10)) CF_retrofit_34_globalreg_95];
                                
                           elseif NPV_retrofit_34_globalreg_100 >= NPV_sell_34_globalreg && NPV_retrofit_34_globalreg_100 >= NPV_retrofit_34_globalreg_95
               
                                CF_sail_another_route_localreg_12_globalreg_34 = [CF_sail_another_route_12_localreg(1,(1:10)) CF_retrofit_34_globalreg_100];
                           
                           elseif NPV_sell_34_globalreg >= NPV_retrofit_34_globalreg_95 && NPV_sell_34_globalreg >= NPV_retrofit_34_globalreg_100
         
                                CF_sail_another_route_localreg_12_globalreg_34 = [CF_sail_another_route_12_localreg(1,(1:10)) CF_sell_34_globalreg];
                           end
                           Global_regulation = 1;
                       end 
                    
                    % Need to check if a global regulation is introduced between epoch 4-5.
                       if (Era_generation(k,19,Era) == 1 && k == 5 && l == 1 && Global_regulation == 0) || (Era_generation(k,21,Era) == 1 && k == 5 && l == 1 && Global_regulation == 0)
                            
                           for m = 5:6
                                for n = 1:5
                                
                                % Have to either retrofit or sell!    
                                
                                % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                if Era_generation(m,19,Era) == 1 && m == 5 && n == 1 
                                    Retrofit = 1;
                                    Shipyard = 1;
                                    CAPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                    Revenue_retrofit_45_globalreg_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                elseif Era_generation(m,19,Era) == 1
                                    Retrofit = 1;
                                    CAPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = CAPEX(m,n,Ship_design);
                                    OPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_45_globalreg_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end
                                
                                % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                % Construction year:
                                if m == 5 && n == 1  
                                    Retrofit = 2;
                                    Shipyard = 1;
                                    CAPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_45_globalreg_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                else
                                    Retrofit = 2;
                                    Hydrogen = 1;
                                    CAPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                    Revenue_retrofit_45_globalreg_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end

                                % Sell option: 
                                if m == 5 && n == 1
                                    Retrofit = 0;
                                    CAPEX_sell_45_globalreg(n+((m-5)*5)) = 0; 
                                    OPEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    VOYEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    Revenue_sell_45_globalreg(n+((m-5)*5)) = Sell(m,Era,Era_generation,Ship_design) - Loan_balance(m,n,Ship_design);
                                else
                                    Retrofit = 0;
                                    CAPEX_sell_45_globalreg(n+((m-5)*5)) = 0; 
                                    OPEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    VOYEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    Revenue_sell_45_globalreg(n+((m-5)*5)) = 0;    
                                end
            
                                CF_retrofit_45_globalreg_95(n+((m-5)*5)) = Revenue_retrofit_45_globalreg_95(n+((m-5)*5)) - ...
                                    CAPEX_retrofit_45_globalreg_95(n+((m-5)*5)) - OPEX_retrofit_45_globalreg_95(n+((m-5)*5)) - VOYEX_retrofit_45_globalreg_95(n+((m-5)*5));
                                
                                CF_retrofit_45_globalreg_100(n+((m-5)*5)) = Revenue_retrofit_45_globalreg_100(n+((m-5)*5)) - ...
                                    CAPEX_retrofit_45_globalreg_100(n+((m-5)*5)) - OPEX_retrofit_45_globalreg_100(n+((m-5)*5)) - VOYEX_retrofit_45_globalreg_100(n+((m-5)*5));
                                
                                CF_sell_45_globalreg(n+((m-5)*5)) = Revenue_sell_45_globalreg(n+((m-5)*5)) - ...
                                    CAPEX_sell_45_globalreg(n+((m-5)*5)) - OPEX_sell_45_globalreg(n+((m-5)*5)) - VOYEX_sell_45_globalreg(n+((m-5)*5));
            
                                end
                           end
                       

                           NPV_retrofit_45_globalreg_95 = NPV(CF_retrofit_45_globalreg_95,d_r,10);
                           NPV_retrofit_45_globalreg_100 = NPV(CF_retrofit_45_globalreg_100,d_r,10);
                           NPV_sell_45_globalreg = NPV(CF_sell_45_globalreg,d_r,10);
            
                           if NPV_retrofit_45_globalreg_95 >= NPV_sell_45_globalreg && NPV_retrofit_45_globalreg_95 >= NPV_retrofit_45_globalreg_100
                
                                CF_sail_another_route_localreg_12_globalreg_45 = [CF_sail_another_route_12_localreg(1,(1:15)) CF_retrofit_45_globalreg_95];
                                
                           elseif NPV_retrofit_45_globalreg_100 >= NPV_sell_45_globalreg && NPV_retrofit_45_globalreg_100 >= NPV_retrofit_45_globalreg_95
                
                                CF_sail_another_route_localreg_12_globalreg_45 = [CF_sail_another_route_12_localreg(1,(1:15)) CF_retrofit_45_globalreg_100];     
                                
                           elseif NPV_sell_45_globalreg >= NPV_retrofit_45_globalreg_95 && NPV_sell_45_globalreg >= NPV_retrofit_45_globalreg_100
            
                                CF_sail_another_route_localreg_12_globalreg_45 = [CF_sail_another_route_12_localreg(1,(1:15)) CF_sell_45_globalreg];
                           end
                           Global_regulation = 1;
                        end 
                       
                    % Need to check if a global regulation is introduced between epoch 5-6.
                       if (Era_generation(k,19,Era) == 1 && k == 6 && l == 1 && Global_regulation == 0) || (Era_generation(k,21,Era) == 1 && k == 6 && l == 1 && Global_regulation == 0)
                            
                           for m = 6:6
                                for n = 1:5
                                
                                    % Have to either retrofit or sell!    
                                    
                                    % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                    if Era_generation(m,19,Era) == 1 && m == 6 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(m,19,Era) == 1
                                        Retrofit = 1;
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                    % Construction year:
                                    if m == 6 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    % Sell option: 
                                    if m == 6 && n == 1
                                        Retrofit = 0;
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) = 0; 
                                        OPEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        VOYEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        Revenue_sell_56_globalreg(n+((m-6)*5)) = Sell(m,Era,Era_generation,Ship_design) - Loan_balance(m,n,Ship_design);
                                    else
                                        Retrofit = 0;
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) = 0; 
                                        OPEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        VOYEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        Revenue_sell_56_globalreg(n+((m-6)*5)) = 0;    
                                    end
            
                                    CF_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) - OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) - VOYEX_retrofit_56_globalreg_95(n+((m-6)*5));
                                    
                                    CF_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) - OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) - VOYEX_retrofit_56_globalreg_100(n+((m-6)*5));
                                    
                                    CF_sell_56_globalreg(n+((m-6)*5)) = Revenue_sell_56_globalreg(n+((m-6)*5)) - ...
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) - OPEX_sell_56_globalreg(n+((m-6)*5)) - VOYEX_sell_56_globalreg(n+((m-6)*5));
            
                                end
                           end
            
                           NPV_retrofit_56_globalreg_95 = NPV(CF_retrofit_56_globalreg_95,d_r,5);
                           NPV_retrofit_56_globalreg_100 = NPV(CF_retrofit_56_globalreg_100,d_r,5);
                           NPV_sell_56_globalreg = NPV(CF_sell_56_globalreg,d_r,5);
            
                           if NPV_retrofit_56_globalreg_95 >= NPV_sell_56_globalreg && NPV_retrofit_56_globalreg_95 >= NPV_retrofit_56_globalreg_100
                
                                CF_sail_another_route_localreg_12_globalreg_56 = [CF_sail_another_route_12_localreg(1,(1:20)) CF_retrofit_56_globalreg_95];
                                
                           elseif NPV_retrofit_56_globalreg_100 >= NPV_sell_56_globalreg && NPV_retrofit_56_globalreg_100 >= NPV_retrofit_56_globalreg_95
                
                                CF_sail_another_route_localreg_12_globalreg_56 = [CF_sail_another_route_12_localreg(1,(1:20)) CF_retrofit_56_globalreg_100];     
                                
                           elseif NPV_sell_56_globalreg >= NPV_retrofit_56_globalreg_95 && NPV_sell_56_globalreg >= NPV_retrofit_56_globalreg_100
            
                                CF_sail_another_route_localreg_12_globalreg_56 = [CF_sail_another_route_12_localreg(1,(1:20)) CF_sell_56_globalreg];
                           end
                           Global_regulation = 1;
                       end   
                       
                       
                    % The option to make a retrofit eventhough the regulation is not requiering it.
                    
                    % Optional retrofit for local zero-emission zone between epoch 2-3.
                    % (Need to check if globale zero emission regulation have been introduced at this epoch.) 
                       if k == 3 && l == 1 && Era_generation(k,19,Era) == 0 && Era_generation(k,21,Era) == 0
                            
                           for m = 3:6
                                for n = 1:5
     
                                    % Retrofit option (95% zero emission):
                                    if Era_generation(3,19,Era) == 0 && Era_generation(3,21,Era) == 0 && Era_generation(4,21,Era) == 0 ...
                                            && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(2,20,Era) == 0 ...
                                            && m == 3 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_23_optional_95(n+((m-3)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_23_optional_95(n+((m-3)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_23_optional_95(n+((m-3)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_23_optional_95(n+((m-3)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(3,19,Era) == 0 && Era_generation(3,21,Era) == 0 && Era_generation(4,21,Era) == 0 ...
                                            && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(2,20,Era) == 0
                                        Retrofit = 1;
                                        CAPEX_retrofit_23_optional_95(n+((m-3)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_23_optional_95(n+((m-3)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_23_optional_95(n+((m-3)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_23_optional_95(n+((m-3)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                    % Construction year:
                                    if m == 3 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_23_optional_100(n+((m-3)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_23_optional_100(n+((m-3)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_23_optional_100(n+((m-3)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_23_optional_100(n+((m-3)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_23_optional_100(n+((m-3)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_23_optional_100(n+((m-3)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_23_optional_100(n+((m-3)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_23_optional_100(n+((m-3)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    CF_optional_23_95(n+((m-3)*5)) = Revenue_retrofit_23_optional_95(n+((m-3)*5)) - ...
                                        CAPEX_retrofit_23_optional_95(n+((m-3)*5)) - OPEX_retrofit_23_optional_95(n+((m-3)*5)) - VOYEX_retrofit_23_optional_95(n+((m-3)*5));
                                    
                                    CF_optional_23_100(n+((m-3)*5)) = Revenue_retrofit_23_optional_100(n+((m-3)*5)) - ...
                                        CAPEX_retrofit_23_optional_100(n+((m-3)*5)) - OPEX_retrofit_23_optional_100(n+((m-3)*5)) - VOYEX_retrofit_23_optional_100(n+((m-3)*5));
                                end
                           end
                           
                           NPV_optional_23_95 = NPV(CF_optional_23_95,d_r,20);
                           NPV_optional_23_100 = NPV(CF_optional_23_100,d_r,20);
                           
                           if NPV_optional_23_95 >= NPV_optional_23_100
                                 
                               CF_retrofit_23_optional = [CF_sail_another_route_12_localreg(1,(1:5)) CF_optional_23_95];
                               
                           elseif NPV_optional_23_100 > NPV_optional_23_95
                       
                               CF_retrofit_23_optional = [CF_sail_another_route_12_localreg(1,(1:5)) CF_optional_23_100];
                           
                           end
                       end
                      
                           
                    % Optional retrofit for local zero-emission zone between epoch 3-4.
                    % (Need to check if globale zero emission regulation have been introduced before and at this epoch.)  
                       if k == 4 && l == 1 && Era_generation(k-1,19,Era) == 0 && Era_generation(k,19,Era) == 0 && ...
                               Era_generation(k-1,21,Era) == 0 && Era_generation(k,21,Era) == 0
                            
                           for m = 4:6
                                for n = 1:5
                                    
                                    % Retrofit option (95% zero emission): 
                                    if Era_generation(3,19,Era) == 0 && Era_generation(4,19,Era) == 0 && Era_generation(3,21,Era) == 0 && Era_generation(4,21,Era) == 0 ...
                                            && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(2,20,Era) == 0 ...
                                            && m == 4 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_34_optional_95(n+((m-4)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_34_optional_95(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_34_optional_95(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_34_optional_95(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(3,19,Era) == 0 && Era_generation(4,19,Era) == 0 && Era_generation(3,21,Era) == 0 && Era_generation(4,21,Era) == 0 ...
                                            && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(2,20,Era) == 0
                                        Retrofit = 1;
                                        CAPEX_retrofit_34_optional_95(n+((m-4)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_34_optional_95(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_34_optional_95(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_34_optional_95(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                    % Construction year:
                                    if m == 4 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_34_optional_100(n+((m-4)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_34_optional_100(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_34_optional_100(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_34_optional_100(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_34_optional_100(n+((m-4)*5)) = CAPEX(m,n,Ship_design);
                                        OPEX_retrofit_34_optional_100(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_34_optional_100(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_34_optional_100(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    CF_optional_34_95(n+((m-4)*5)) = Revenue_retrofit_34_optional_95(n+((m-4)*5)) - ...
                                        CAPEX_retrofit_34_optional_95(n+((m-4)*5)) - OPEX_retrofit_34_optional_95(n+((m-4)*5)) - VOYEX_retrofit_34_optional_95(n+((m-4)*5));
                                    
                                    CF_optional_34_100(n+((m-4)*5)) = Revenue_retrofit_34_optional_100(n+((m-4)*5)) - ...
                                        CAPEX_retrofit_34_optional_100(n+((m-4)*5)) - OPEX_retrofit_34_optional_100(n+((m-4)*5)) - VOYEX_retrofit_34_optional_100(n+((m-4)*5));
            
                                end
                           end
                           
                           NPV_optional_34_95 = NPV(CF_optional_34_95,d_r,15);
                           NPV_optional_34_100 = NPV(CF_optional_34_100,d_r,15);
                           
                           if NPV_optional_34_95 >= NPV_optional_34_100
                           
                               CF_retrofit_34_optional = [CF_sail_another_route_12_localreg(1,(1:10)) CF_optional_34_95]; 
                           
                           elseif NPV_optional_34_100 > NPV_optional_34_95
                               
                               CF_retrofit_34_optional = [CF_sail_another_route_12_localreg(1,(1:10)) CF_optional_34_100];
                           end
                           
                       end
                       
                    % Optional retrofit for local zero-emission zone between epoch 4-5. 
                    % (Need to check if globale zero emission regulation have been introduced before and at this epoch.)  
                       if k == 5 && l == 1 && Era_generation(k-2,19,Era) == 0 && Era_generation(k-1,19,Era) == 0 && Era_generation(k,19,Era) == 0 ...
                               && Era_generation(k-2,21,Era) == 0 && Era_generation(k-1,21,Era) == 0 && Era_generation(k,21,Era) == 0
                        
                           for m = 5:6
                                for n = 1:5
     
                                    % Retrofit option (95% zero emission):
                                    if Era_generation(3,19,Era) == 0 && Era_generation(4,19,Era) == 0 && Era_generation(5,19,Era) == 0 && Era_generation(3,21,Era) == 0 ...
                                            && Era_generation(4,21,Era) == 0 && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(2,20,Era) == 0 ...
                                            && m == 5 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_45_optional_95(n+((m-5)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_45_optional_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_45_optional_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(3,19,Era) == 0 && Era_generation(4,19,Era) == 0 && Era_generation(5,19,Era) == 0 && Era_generation(3,21,Era) == 0 ...
                                            && Era_generation(4,21,Era) == 0 && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(2,20,Era) == 0
                                        Retrofit = 1;
                                        CAPEX_retrofit_45_optional_95(n+((m-5)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_45_optional_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_45_optional_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    
                                    % Retrofit option (100% zero emission):
                                    % Construction year:
                                    if m == 5 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_45_optional_100(n+((m-5)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_45_optional_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_45_optional_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_45_optional_100(n+((m-5)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_45_optional_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_45_optional_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    CF_optional_45_95(n+((m-5)*5)) = Revenue_retrofit_45_optional_95(n+((m-5)*5)) - ...
                                        CAPEX_retrofit_45_optional_95(n+((m-5)*5)) - OPEX_retrofit_45_optional_95(n+((m-5)*5)) - VOYEX_retrofit_45_optional_95(n+((m-5)*5));
                                    
                                    CF_optional_45_100(n+((m-5)*5)) = Revenue_retrofit_45_optional_100(n+((m-5)*5)) - ...
                                        CAPEX_retrofit_45_optional_100(n+((m-5)*5)) - OPEX_retrofit_45_optional_100(n+((m-5)*5)) - VOYEX_retrofit_45_optional_100(n+((m-5)*5));
                                end
                           end
                           
                           NPV_optional_45_95 = NPV(CF_optional_45_95,d_r,10);
                           NPV_optional_45_100 = NPV(CF_optional_45_100,d_r,10);
                           
                           if NPV_optional_45_95 >= NPV_optional_45_100
                               
                                CF_retrofit_45_optional = [CF_sail_another_route_12_localreg(1,(1:15)) CF_optional_45_95];
                           
                           elseif NPV_optional_45_100 > NPV_optional_45_95
                               
                               CF_retrofit_45_optional = [CF_sail_another_route_12_localreg(1,(1:15)) CF_optional_45_100];
                           end
                           
                       end
                       
                    % Optional retrofit for local zero-emission zone between epoch 5-6. 
                    % (Need to check if globale zero emission regulation have been introduced before and at this epoch.) 
                       if k == 6 && l == 1 && Era_generation(k-3,19,Era) == 0 && Era_generation(k-2,19,Era) == 0 && Era_generation(k-1,19,Era) == 0 && ...
                               Era_generation(k,19,Era) == 0 && Era_generation(k-3,21,Era) == 0 && Era_generation(k-2,21,Era) == 0 ...
                               && Era_generation(k-1,21,Era) == 0 && Era_generation(k,21,Era) == 0
                            
                           for m = 6:6
                                for n = 1:5
                                    
                                    % Retrofit option (95% zero emission):
                                    % Construction year:
                                    if Era_generation(3,19,Era) == 0 && Era_generation(4,19,Era) == 0 && Era_generation(5,19,Era) == 0 && Era_generation(6,19,Era) == 0 ...
                                            && Era_generation(3,21,Era) == 0 && Era_generation(4,21,Era) == 0 && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 && ...
                                            Era_generation(2,20,Era) == 0 && m == 6 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(3,19,Era) == 0 && Era_generation(4,19,Era) == 0 && Era_generation(5,19,Era) == 0 && Era_generation(6,19,Era) == 0 ...
                                            && Era_generation(3,21,Era) == 0 && Era_generation(4,21,Era) == 0 && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 && ...
                                            Era_generation(2,20,Era) == 0
                                        Retrofit = 1;
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_optional_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    % Retrofit option (100% zero emission):
                                    % Construction year:
                                    if m == 6 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_optional_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    CF_optional_56_95(n+((m-6)*5)) = Revenue_retrofit_56_optional_95(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) - OPEX_retrofit_56_optional_95(n+((m-6)*5)) - VOYEX_retrofit_56_optional_95(n+((m-6)*5));
            
                                    CF_optional_56_100(n+((m-6)*5)) = Revenue_retrofit_56_optional_100(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) - OPEX_retrofit_56_optional_100(n+((m-6)*5)) - VOYEX_retrofit_56_optional_100(n+((m-6)*5));
                                end
                           end
                            
                           NPV_optional_56_95 = NPV(CF_optional_56_95,d_r,5);
                           NPV_optional_56_100 = NPV(CF_optional_56_100,d_r,5);
                           
                           if NPV_optional_56_95 >= NPV_optional_56_100
                               CF_retrofit_56_optional = [CF_sail_another_route_12_localreg(1,(1:20)) CF_optional_56_95];
                               
                           elseif NPV_optional_56_100 > NPV_optional_56_95
                               CF_retrofit_56_optional = [CF_sail_another_route_12_localreg(1,(1:20)) CF_optional_56_100];
                           end
                       end
                       
                    % Sell option: 
                    if k == 2 && l == 1
                        Retrofit = 0;
                        CAPEX_sell_12_localreg(l+((k-2)*5)) = 0; 
                        OPEX_sell_12_localreg(l+((k-2)*5)) = 0;
                        VOYEX_sell_12_localreg(l+((k-2)*5)) = 0;
                        Revenue_sell_12_localreg(l+((k-2)*5)) = Sell(k,Era,Era_generation,Ship_design) - Loan_balance(k,l,Ship_design);
                    else
                        Retrofit = 0;
                        CAPEX_sell_12_localreg(l+((k-2)*5)) = 0; 
                        OPEX_sell_12_localreg(l+((k-2)*5)) = 0;
                        VOYEX_sell_12_localreg(l+((k-2)*5)) = 0;
                        Revenue_sell_12_localreg(l+((k-2)*5)) = 0;    
                    end
                    
                    
                    CF_retrofit_12_localreg_95(l+((k-2)*5)) = Revenue_retrofit_12_localreg_95(l+((k-2)*5)) - ...
                        CAPEX_retrofit_12_localreg_95(l+((k-2)*5)) - OPEX_retrofit_12_localreg_95(l+((k-2)*5)) - VOYEX_retrofit_12_localreg_95(l+((k-2)*5));
                    
                    CF_retrofit_12_localreg_100(l+((k-2)*5)) = Revenue_retrofit_12_localreg_100(l+((k-2)*5)) - ...
                        CAPEX_retrofit_12_localreg_100(l+((k-2)*5)) - OPEX_retrofit_12_localreg_100(l+((k-2)*5)) - VOYEX_retrofit_12_localreg_100(l+((k-2)*5));
                    
                    CF_sail_another_route_12_localreg(l+((k-2)*5)) = Revenue_sail_another_route_12_localreg(l+((k-2)*5)) - ...
                        CAPEX_sail_another_route_12_localreg(l+((k-2)*5)) - OPEX_sail_another_route_12_localreg(l+((k-2)*5)) - VOYEX_sail_another_route_12_localreg(l+((k-2)*5));
                    
                    CF_sell_12_localreg(l+((k-2)*5)) = Revenue_sell_12_localreg(l+((k-2)*5)) - ...
                        CAPEX_sell_12_localreg(l+((k-2)*5)) - OPEX_sell_12_localreg(l+((k-2)*5)) - VOYEX_sell_12_localreg(l+((k-2)*5));   
                end
           end
                
                % NPV from year 5-30: Retrofit, sail another route or sell.
                NPV_retrofit_12_localreg_95 = NPV(CF_retrofit_12_localreg_95,d_r,25);
                NPV_retrofit_12_localreg_100 = NPV(CF_retrofit_12_localreg_100,d_r,25);
                
                % If no global regualtions are introduced. 
                if Era_generation(3,19,Era) == 0 && Era_generation(4,19,Era) == 0 && Era_generation(5,19,Era) == 0 && ...
                        Era_generation(6,19,Era) == 0 && Era_generation(3,21,Era) == 0 && Era_generation(4,21,Era) == 0 && ...
                        Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0
                    NPV_sail_another_route_12_localreg = NPV(CF_sail_another_route_12_localreg,d_r,25); % No retrofits, just sailing another route the whole time.  
                else
                    NPV_sail_another_route_12_localreg = 0;
                end
                
                NPV_sell_12_localreg = NPV(CF_sell_12_localreg,d_r,25);
                
                % NPV from year 5-30: Sail another route including global regulations at a later point in time. 
                NPV_sail_another_route_localreg_12_globalreg_23 = NPV(CF_sail_another_route_localreg_12_globalreg_23,d_r,25);
                NPV_sail_another_route_localreg_12_globalreg_34 = NPV(CF_sail_another_route_localreg_12_globalreg_34,d_r,25);
                NPV_sail_another_route_localreg_12_globalreg_45 = NPV(CF_sail_another_route_localreg_12_globalreg_45,d_r,25);
                NPV_sail_another_route_localreg_12_globalreg_56 = NPV(CF_sail_another_route_localreg_12_globalreg_56,d_r,25);
                
                % Optional retrofit for zero-emission compliance. 
                NPV_retrofit_23_optional = NPV(CF_retrofit_23_optional,d_r,25);
                NPV_retrofit_34_optional = NPV(CF_retrofit_34_optional,d_r,25);
                NPV_retrofit_45_optional = NPV(CF_retrofit_45_optional,d_r,25);
                NPV_retrofit_56_optional = NPV(CF_retrofit_56_optional,d_r,25);
                
                % Collecting the 11 NPV values into one vector: 
                NPV_vector = [NPV_retrofit_12_localreg_95 NPV_retrofit_12_localreg_100 NPV_sail_another_route_12_localreg ...
                    NPV_sell_12_localreg NPV_sail_another_route_localreg_12_globalreg_23 NPV_sail_another_route_localreg_12_globalreg_34 ...
                    NPV_sail_another_route_localreg_12_globalreg_45 NPV_sail_another_route_localreg_12_globalreg_56 ...
                    NPV_retrofit_23_optional NPV_retrofit_34_optional NPV_retrofit_45_optional NPV_retrofit_56_optional];
                
                % Select the one that maximises the NPV value for the rest
                % of the lifetime of the ship. 
                if max(NPV_vector) == NPV_vector(1)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_retrofit_12_localreg_95]; 
                    
                elseif max(NPV_vector) == NPV_vector(2)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_retrofit_12_localreg_100];
                    
                elseif max(NPV_vector) == NPV_vector(3)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_sail_another_route_12_localreg];
                    
                elseif max(NPV_vector) == NPV_vector(4)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_sell_12_localreg];
                     
                elseif max(NPV_vector) == NPV_vector(5)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_sail_another_route_localreg_12_globalreg_23];
                    
                elseif max(NPV_vector) == NPV_vector(6)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_sail_another_route_localreg_12_globalreg_34];
  
                elseif max(NPV_vector) == NPV_vector(7)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_sail_another_route_localreg_12_globalreg_45];
     
                elseif max(NPV_vector) == NPV_vector(8)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_sail_another_route_localreg_12_globalreg_56];
                    
                elseif max(NPV_vector) == NPV_vector(9)    
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_retrofit_23_optional];
                    
                elseif max(NPV_vector) == NPV_vector(10)    
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_retrofit_34_optional];
                    
                elseif max(NPV_vector) == NPV_vector(11)    
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_retrofit_45_optional];
                    
                elseif max(NPV_vector) == NPV_vector(12)    
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:5)) CF_retrofit_56_optional];
                    
                end
               finishNow = true;         
        end

        % Terminates the inner for-loop
        if finishNow 
        break
        end
    
    % Terminates the outer for-loop
    if finishNow
    break
    end
        
     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Epoch 2 -> 3
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


        % Check for global zero-emission regulation
        % Check if global zero-emission regulation occurs between epoch
        % 2-3.
        
        if (Era_generation(i,19,Era) == 1 && i == 3 && j == 1) || (Era_generation(i,21,Era) == 1 && i == 3 && j == 1)
            
            for k = 3:6
                for l = 1:5
            
                    % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!) 
                    % The fuels are here assumed as drop-in fuelsNo CAPEX cost for retrofit is assumed,
                    if Era_generation(k,19,Era) == 1 && k == 3 && l == 1
                        Retrofit = 1;
                        Shipyard = 1;
                        CAPEX_retrofit_23_globalreg_95(l+((k-3)*5)) = CAPEX_retrofit_ammonia + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_23_globalreg_95(l+((k-3)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_23_globalreg_95(l+((k-3)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                        Revenue_retrofit_23_globalreg_95(l+((k-3)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    elseif Era_generation(k,19,Era) == 1
                        Retrofit = 1;
                        CAPEX_retrofit_23_globalreg_95(l+((k-3)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_23_globalreg_95(l+((k-3)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_23_globalreg_95(l+((k-3)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_23_globalreg_95(l+((k-3)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    
                    % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                    if k == 3 && l == 1  
                        Retrofit = 2;
                        Shipyard = 1;
                        CAPEX_retrofit_23_globalreg_100(l+((k-3)*5)) = CAPEX_retrofit_hydrogen + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_23_globalreg_100(l+((k-3)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_23_globalreg_100(l+((k-3)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_23_globalreg_100(l+((k-3)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    else
                        Retrofit = 2;
                        Hydrogen = 1;
                        CAPEX_retrofit_23_globalreg_100(l+((k-3)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_23_globalreg_100(l+((k-3)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_23_globalreg_100(l+((k-3)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_23_globalreg_100(l+((k-3)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    

                    % Sell option: 
                    if k == 3 && l == 1
                        Retrofit = 0;
                        CAPEX_sell_23_globalreg(l+((k-3)*5)) = 0; 
                        OPEX_sell_23_globalreg(l+((k-3)*5)) = 0;
                        VOYEX_sell_23_globalreg(l+((k-3)*5)) = 0;
                        Revenue_sell_23_globalreg(l+((k-3)*5)) = Sell(k,Era,Era_generation,Ship_design) - Loan_balance(k,l,Ship_design);
                    else
                        Retrofit = 0;
                        CAPEX_sell_23_globalreg(l+((k-3)*5)) = 0; 
                        OPEX_sell_23_globalreg(l+((k-3)*5)) = 0;
                        VOYEX_sell_23_globalreg(l+((k-3)*5)) = 0;
                        Revenue_sell_23_globalreg(l+((k-3)*5)) = 0;    
                    end
            
                    CF_retrofit_23_globalreg_95(l+((k-3)*5)) = Revenue_retrofit_23_globalreg_95(l+((k-3)*5)) - ...
                        CAPEX_retrofit_23_globalreg_95(l+((k-3)*5)) - OPEX_retrofit_23_globalreg_95(l+((k-3)*5)) - VOYEX_retrofit_23_globalreg_95(l+((k-3)*5));
                    
                    CF_retrofit_23_globalreg_100(l+((k-3)*5)) = Revenue_retrofit_23_globalreg_100(l+((k-3)*5)) - ...
                        CAPEX_retrofit_23_globalreg_100(l+((k-3)*5)) - OPEX_retrofit_23_globalreg_100(l+((k-3)*5)) - VOYEX_retrofit_23_globalreg_100(l+((k-3)*5));
            
                    CF_sell_23_globalreg(l+((k-3)*5)) = Revenue_sell_23_globalreg(l+((k-3)*5)) - ...
                        CAPEX_sell_23_globalreg(l+((k-3)*5)) - OPEX_sell_23_globalreg(l+((k-3)*5)) - VOYEX_sell_23_globalreg(l+((k-3)*5));
            
                end
            end
            
            NPV_retrofit_23_globalreg_95 = NPV(CF_retrofit_23_globalreg_95,d_r,20);
            NPV_retrofit_23_globalreg_100 = NPV(CF_retrofit_23_globalreg_100,d_r,20);
            NPV_sell_23_globalreg = NPV(CF_sell_23_globalreg,d_r,20);
            
            if NPV_retrofit_23_globalreg_95 >= NPV_sell_23_globalreg && NPV_retrofit_23_globalreg_95 >= NPV_retrofit_23_globalreg_100
                
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_retrofit_23_globalreg_95];
            
            elseif NPV_retrofit_23_globalreg_100 >= NPV_sell_23_globalreg && NPV_retrofit_23_globalreg_100 >= NPV_retrofit_23_globalreg_95
                
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_retrofit_23_globalreg_100];     
                
            elseif NPV_sell_23_globalreg >= NPV_retrofit_23_globalreg_95 && NPV_sell_23_globalreg >= NPV_retrofit_23_globalreg_100
  
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_sell_23_globalreg];
            
            end
            finishNow = true;
        end
        % Terminates the inner for-loop
        if finishNow 
        break
        end
    
    
    % Terminates the outer for-loop
    if finishNow
    break
    end

    
    
    % Check if local zero-emission regulation occurs between epoch 2-3.
        
        if (Era_generation(i,18,Era) == 1 && i == 3 && j == 1) || (Era_generation(i,20,Era) == 1 && i == 3 && j == 1)
            
           for k = 3:6
                for l = 1:5
            
                    % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future 95% zero emission zones also!)
                    if Era_generation(i,18,Era) == 1 && k == 3 && l == 1
                        Retrofit = 1;
                        Shipyard = 1;
                        CAPEX_retrofit_23_localreg_95(l+((k-3)*5)) = CAPEX_retrofit_ammonia + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_23_localreg_95(l+((k-3)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_23_localreg_95(l+((k-3)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_23_localreg_95(l+((k-3)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    elseif Era_generation(i,18,Era) == 1
                        Retrofit = 1;
                        CAPEX_retrofit_23_localreg_95(l+((k-3)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_23_localreg_95(l+((k-3)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_23_localreg_95(l+((k-3)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_23_localreg_95(l+((k-3)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);    
                    end

                    % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future 100% zero emission zones also!)
                    % Construction year:
                    if k == 3 && l == 1  
                        Retrofit = 2;
                        Shipyard = 1;
                        CAPEX_retrofit_23_localreg_100(l+((k-3)*5)) = CAPEX_retrofit_hydrogen + CAPEX(k,l,Ship_design);
                        OPEX_retrofit_23_localreg_100(l+((k-3)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_23_localreg_100(l+((k-3)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                        Revenue_retrofit_23_localreg_100(l+((k-3)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    else
                        Retrofit = 2;
                        Hydrogen = 1;
                        CAPEX_retrofit_23_localreg_100(l+((k-3)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_23_localreg_100(l+((k-3)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_23_localreg_100(l+((k-3)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_23_localreg_100(l+((k-3)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    
                    % Sail another route option:
                    % Calculate for epoch 3,4,5,6 (depending on "global zero-emission" is introduced or not) 
                    Retrofit = 0;
                    CAPEX_sail_another_route_23_localreg(l+((k-3)*5)) = CAPEX(k,l,Ship_design); 
                    OPEX_sail_another_route_23_localreg(l+((k-3)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                    VOYEX_sail_another_route_23_localreg(l+((k-3)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                    Revenue_sail_another_route_23_localreg(l+((k-3)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard) - (Revenue(k,l,Retrofit,Ship_design,Shipyard)*Revenue_time_loss);  
                    
                    
                      % Need to check if a global regulation is introduced between epoch 3-4.
                       if (Era_generation(k,19,Era) == 1 && k == 4 && l == 1 && Global_regulation == 0) || (Era_generation(k,21,Era) == 1 && k == 4 && l == 1 && Global_regulation == 0)
                            
                           for m = 4:6
                                for n = 1:5
                                
                                % Have to either retrofit or sell!    
                                
                                % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                % Construction year:
                                if Era_generation(m,19,Era) == 1 && m == 4 && n == 1   
                                    Retrofit = 1;
                                    Shipyard = 1;
                                    CAPEX_retrofit_34_globalreg_95(n+((m-4)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_34_globalreg_95(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_34_globalreg_95(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                    Revenue_retrofit_34_globalreg_95(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                elseif Era_generation(m,19,Era) == 1   
                                    Retrofit = 1;
                                    CAPEX_retrofit_34_globalreg_95(n+((m-4)*5)) = CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_34_globalreg_95(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_34_globalreg_95(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_34_globalreg_95(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end
                                
                                % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                % Construction year:
                                if m == 4 && n == 1  
                                    Retrofit = 2;
                                    Shipyard = 1;
                                    CAPEX_retrofit_34_globalreg_100(n+((m-4)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_34_globalreg_100(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_34_globalreg_100(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_34_globalreg_100(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                else
                                    Retrofit = 2;
                                    Hydrogen = 1;
                                    CAPEX_retrofit_34_globalreg_100(n+((m-4)*5)) = CAPEX(m,n,Ship_design);
                                    OPEX_retrofit_34_globalreg_100(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_34_globalreg_100(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_34_globalreg_100(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end

                                % Sell option: 
                                if m == 4 && n == 1
                                    Retrofit = 0;
                                    CAPEX_sell_34_globalreg(n+((m-4)*5)) = 0; 
                                    OPEX_sell_34_globalreg(n+((m-4)*5)) = 0;
                                    VOYEX_sell_34_globalreg(n+((m-4)*5)) = 0;
                                    Revenue_sell_34_globalreg(n+((m-4)*5)) = Sell(m,Era,Era_generation,Ship_design) - Loan_balance(m,n,Ship_design);
                                else
                                    Retrofit = 0;
                                    CAPEX_sell_34_globalreg(n+((m-4)*5)) = 0; 
                                    OPEX_sell_34_globalreg(n+((m-4)*5)) = 0;
                                    VOYEX_sell_34_globalreg(n+((m-4)*5)) = 0;
                                    Revenue_sell_34_globalreg(n+((m-4)*5)) = 0;    
                                end
            
                                CF_retrofit_34_globalreg_95(n+((m-4)*5)) = Revenue_retrofit_34_globalreg_95(n+((m-4)*5)) - ...
                                    CAPEX_retrofit_34_globalreg_95(n+((m-4)*5)) - OPEX_retrofit_34_globalreg_95(n+((m-4)*5)) - VOYEX_retrofit_34_globalreg_95(n+((m-4)*5));
                                
                                CF_retrofit_34_globalreg_100(n+((m-4)*5)) = Revenue_retrofit_34_globalreg_100(n+((m-4)*5)) - ...
                                    CAPEX_retrofit_34_globalreg_100(n+((m-4)*5)) - OPEX_retrofit_34_globalreg_100(n+((m-4)*5)) - VOYEX_retrofit_34_globalreg_100(n+((m-4)*5));
                                
                                CF_sell_34_globalreg(n+((m-4)*5)) = Revenue_sell_34_globalreg(n+((m-4)*5)) - ...
                                    CAPEX_sell_34_globalreg(n+((m-4)*5)) - OPEX_sell_34_globalreg(n+((m-4)*5)) - VOYEX_sell_34_globalreg(n+((m-4)*5));
            
                                end
                           end
            
                           NPV_retrofit_34_globalreg_95 = NPV(CF_retrofit_34_globalreg_95,d_r,15);
                           NPV_retrofit_34_globalreg_100 = NPV(CF_retrofit_34_globalreg_100,d_r,15);
                           NPV_sell_34_globalreg = NPV(CF_sell_34_globalreg,d_r,15);
            
                           if NPV_retrofit_34_globalreg_95 >= NPV_sell_34_globalreg && NPV_retrofit_34_globalreg_95 >= NPV_retrofit_34_globalreg_100
                
                                CF_sail_another_route_localreg_23_globalreg_34 = [CF_sail_another_route_23_localreg(1,(1:5)) CF_retrofit_34_globalreg_95];

                           elseif NPV_retrofit_34_globalreg_100 >= NPV_sell_34_globalreg && NPV_retrofit_34_globalreg_100 >= NPV_retrofit_34_globalreg_95
               
                                CF_sail_another_route_localreg_23_globalreg_34 = [CF_sail_another_route_23_localreg(1,(1:5)) CF_retrofit_34_globalreg_100];
                           
                           elseif NPV_sell_34_globalreg >= NPV_retrofit_34_globalreg_95 && NPV_sell_34_globalreg >= NPV_retrofit_34_globalreg_100
         
                                CF_sail_another_route_localreg_23_globalreg_34 = [CF_sail_another_route_23_localreg(1,(1:5)) CF_sell_34_globalreg];
                           end
                           Global_regulation = 1;
                       end 
                    
                    % Need to check if a global regulation is introduced between epoch 4-5.
                       if (Era_generation(k,19,Era) == 1 && k == 5 && l == 1 && Global_regulation == 0) || (Era_generation(k,21,Era) == 1 && k == 5 && l == 1 && Global_regulation == 0)
                            
                           for m = 5:6
                                for n = 1:5
                                
                                % Have to either retrofit or sell!    
                                
                                % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                if Era_generation(m,19,Era) == 1 && m == 5 && n == 1 
                                    Retrofit = 1;
                                    Shipyard = 1;
                                    CAPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_45_globalreg_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                elseif Era_generation(m,19,Era) == 1
                                    Retrofit = 1;
                                    CAPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                    Revenue_retrofit_45_globalreg_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end
                                
                                % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                % Construction year:
                                if m == 5 && n == 1  
                                    Retrofit = 2;
                                    Shipyard = 1;
                                    CAPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                    Revenue_retrofit_45_globalreg_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                else
                                    Retrofit = 2;
                                    Hydrogen = 1;
                                    CAPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_45_globalreg_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end

                                % Sell option: 
                                if m == 5 && n == 1
                                    Retrofit = 0;
                                    CAPEX_sell_45_globalreg(n+((m-5)*5)) = 0; 
                                    OPEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    VOYEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    Revenue_sell_45_globalreg(n+((m-5)*5)) = Sell(m,Era,Era_generation,Ship_design) - Loan_balance(m,n,Ship_design);
                                else
                                    Retrofit = 0;
                                    CAPEX_sell_45_globalreg(n+((m-5)*5)) = 0; 
                                    OPEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    VOYEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    Revenue_sell_45_globalreg(n+((m-5)*5)) = 0;    
                                end
            
                                CF_retrofit_45_globalreg_95(n+((m-5)*5)) = Revenue_retrofit_45_globalreg_95(n+((m-5)*5)) - ...
                                    CAPEX_retrofit_45_globalreg_95(n+((m-5)*5)) - OPEX_retrofit_45_globalreg_95(n+((m-5)*5)) - VOYEX_retrofit_45_globalreg_95(n+((m-5)*5));
                                
                                CF_retrofit_45_globalreg_100(n+((m-5)*5)) = Revenue_retrofit_45_globalreg_100(n+((m-5)*5)) - ...
                                    CAPEX_retrofit_45_globalreg_100(n+((m-5)*5)) - OPEX_retrofit_45_globalreg_100(n+((m-5)*5)) - VOYEX_retrofit_45_globalreg_100(n+((m-5)*5));
                                
                                CF_sell_45_globalreg(n+((m-5)*5)) = Revenue_sell_45_globalreg(n+((m-5)*5)) - ...
                                    CAPEX_sell_45_globalreg(n+((m-5)*5)) - OPEX_sell_45_globalreg(n+((m-5)*5)) - VOYEX_sell_45_globalreg(n+((m-5)*5));
            
                                end
                           end
                       

                           NPV_retrofit_45_globalreg_95 = NPV(CF_retrofit_45_globalreg_95,d_r,10);
                           NPV_retrofit_45_globalreg_100 = NPV(CF_retrofit_45_globalreg_100,d_r,10);
                           NPV_sell_45_globalreg = NPV(CF_sell_45_globalreg,d_r,10);
            
                           if NPV_retrofit_45_globalreg_95 >= NPV_sell_45_globalreg && NPV_retrofit_45_globalreg_95 >= NPV_retrofit_45_globalreg_100
                
                                CF_sail_another_route_localreg_23_globalreg_45 = [CF_sail_another_route_23_localreg(1,(1:10)) CF_retrofit_45_globalreg_95];
                                
                           elseif NPV_retrofit_45_globalreg_100 >= NPV_sell_45_globalreg && NPV_retrofit_45_globalreg_100 >= NPV_retrofit_45_globalreg_95
                
                                CF_sail_another_route_localreg_23_globalreg_45 = [CF_sail_another_route_23_localreg(1,(1:10)) CF_retrofit_45_globalreg_100];     
                                
                           elseif NPV_sell_45_globalreg >= NPV_retrofit_45_globalreg_95 && NPV_sell_45_globalreg >= NPV_retrofit_45_globalreg_100
            
                                CF_sail_another_route_localreg_23_globalreg_45 = [CF_sail_another_route_23_localreg(1,(1:10)) CF_sell_45_globalreg];
                           end
                           Global_regulation = 1;
                        end 
                       
                    % Need to check if a global regulation is introduced between epoch 5-6.
                       if (Era_generation(k,19,Era) == 1 && k == 6 && l == 1 && Global_regulation == 0) || (Era_generation(k,21,Era) == 1 && k == 6 && l == 1 && Global_regulation == 0)
                            
                           for m = 6:6
                                for n = 1:5
                                
                                    % Have to either retrofit or sell!    
                                    
                                    % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                    if Era_generation(m,19,Era) == 1 && m == 6 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(m,19,Era) == 1
                                        Retrofit = 1;
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = CAPEX(m,n,Ship_design);
                                        OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                    % Construction year:
                                    if m == 6 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    % Sell option: 
                                    if m == 6 && n == 1
                                        Retrofit = 0;
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) = 0; 
                                        OPEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        VOYEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        Revenue_sell_56_globalreg(n+((m-6)*5)) = Sell(m,Era,Era_generation,Ship_design) - Loan_balance(m,n,Ship_design);
                                    else
                                        Retrofit = 0;
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) = 0; 
                                        OPEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        VOYEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        Revenue_sell_56_globalreg(n+((m-6)*5)) = 0;    
                                    end
            
                                    CF_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) - OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) - VOYEX_retrofit_56_globalreg_95(n+((m-6)*5));
                                    
                                    CF_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) - OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) - VOYEX_retrofit_56_globalreg_100(n+((m-6)*5));
                                    
                                    CF_sell_56_globalreg(n+((m-6)*5)) = Revenue_sell_56_globalreg(n+((m-6)*5)) - ...
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) - OPEX_sell_56_globalreg(n+((m-6)*5)) - VOYEX_sell_56_globalreg(n+((m-6)*5));
            
                                end
                           end
            
                           NPV_retrofit_56_globalreg_95 = NPV(CF_retrofit_56_globalreg_95,d_r,5);
                           NPV_retrofit_56_globalreg_100 = NPV(CF_retrofit_56_globalreg_100,d_r,5);
                           NPV_sell_56_globalreg = NPV(CF_sell_56_globalreg,d_r,5);
            
                           if NPV_retrofit_56_globalreg_95 >= NPV_sell_56_globalreg && NPV_retrofit_56_globalreg_95 >= NPV_retrofit_56_globalreg_100
                
                                CF_sail_another_route_localreg_23_globalreg_56 = [CF_sail_another_route_23_localreg(1,(1:15)) CF_retrofit_56_globalreg_95];
                                
                           elseif NPV_retrofit_56_globalreg_100 >= NPV_sell_56_globalreg && NPV_retrofit_56_globalreg_100 >= NPV_retrofit_56_globalreg_95
                
                                CF_sail_another_route_localreg_23_globalreg_56 = [CF_sail_another_route_23_localreg(1,(1:15)) CF_retrofit_56_globalreg_100];     
                                
                           elseif NPV_sell_56_globalreg >= NPV_retrofit_56_globalreg_95 && NPV_sell_56_globalreg >= NPV_retrofit_56_globalreg_100
            
                                CF_sail_another_route_localreg_23_globalreg_56 = [CF_sail_another_route_23_localreg(1,(1:15)) CF_sell_56_globalreg];
                           end
                           Global_regulation = 1;
                       end   
                       
                    
                    % The option to make a retrofit eventhough the regulation is not requiering it.
                           
                    % Optional retrofit for local zero-emission zone between epoch 3-4.
                    % (Need to check if globale zero emission regulation have been introduced before and at this epoch.)  
                       if k == 4 && l == 1 && Era_generation(k,19,Era) == 0 && Era_generation(k,21,Era) == 0
                            
                           for m = 4:6
                                for n = 1:5
                                    
                                    % Retrofit option (95% zero emission): 
                                    if Era_generation(4,19,Era) == 0 && Era_generation(4,21,Era) == 0 && Era_generation(5,21,Era) == 0 && ...
                                            Era_generation(6,21,Era) == 0 && Era_generation(3,20,Era) == 0 && m == 4 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_34_optional_95(n+((m-4)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_34_optional_95(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_34_optional_95(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_34_optional_95(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(4,19,Era) == 0 && Era_generation(4,21,Era) == 0 ...
                                            && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(3,20,Era) == 0
                                        Retrofit = 1;
                                        CAPEX_retrofit_34_optional_95(n+((m-4)*5)) = CAPEX(m,n,Ship_design);
                                        OPEX_retrofit_34_optional_95(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_34_optional_95(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_34_optional_95(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                    % Construction year:
                                    if m == 4 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_34_optional_100(n+((m-4)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_34_optional_100(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_34_optional_100(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_34_optional_100(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_34_optional_100(n+((m-4)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_34_optional_100(n+((m-4)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_34_optional_100(n+((m-4)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_34_optional_100(n+((m-4)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    CF_optional_34_95(n+((m-4)*5)) = Revenue_retrofit_34_optional_95(n+((m-4)*5)) - ...
                                        CAPEX_retrofit_34_optional_95(n+((m-4)*5)) - OPEX_retrofit_34_optional_95(n+((m-4)*5)) - VOYEX_retrofit_34_optional_95(n+((m-4)*5));
                                    
                                    CF_optional_34_100(n+((m-4)*5)) = Revenue_retrofit_34_optional_100(n+((m-4)*5)) - ...
                                        CAPEX_retrofit_34_optional_100(n+((m-4)*5)) - OPEX_retrofit_34_optional_100(n+((m-4)*5)) - VOYEX_retrofit_34_optional_100(n+((m-4)*5));
            
                                end
                           end
                           
                           NPV_optional_34_95 = NPV(CF_optional_34_95,d_r,15);
                           NPV_optional_34_100 = NPV(CF_optional_34_100,d_r,15);
                           
                           if NPV_optional_34_95 >= NPV_optional_34_100
                           
                               CF_retrofit_34_optional = [CF_sail_another_route_23_localreg(1,(1:5)) CF_optional_34_95]; 
                           
                           elseif NPV_optional_34_100 > NPV_optional_34_95
                               
                               CF_retrofit_34_optional = [CF_sail_another_route_23_localreg(1,(1:5)) CF_optional_34_100];
                           end
                           
                       end
                       
                    % Optional retrofit for local zero-emission zone between epoch 4-5. 
                    % (Need to check if globale zero emission regulation have been introduced before and at this epoch.)  
                       if k == 5 && l == 1 && Era_generation(k-1,19,Era) == 0 && Era_generation(k,19,Era) == 0 ...
                               && Era_generation(k-1,21,Era) == 0 && Era_generation(k,21,Era) == 0
                        
                           for m = 5:6
                                for n = 1:5
     
                                    % Retrofit option (95% zero emission):
                                    if Era_generation(5,19,Era) == 0 && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 ...
                                            && Era_generation(3,20,Era) == 0 && m == 5 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_45_optional_95(n+((m-5)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_45_optional_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_45_optional_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(5,19,Era) == 0 && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 ...
                                            && Era_generation(3,20,Era) == 0
                                        Retrofit = 1;
                                        CAPEX_retrofit_45_optional_95(n+((m-5)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_45_optional_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_45_optional_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    
                                    % Retrofit option (100% zero emission):
                                    % Construction year:
                                    if m == 5 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_45_optional_100(n+((m-5)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design);
                                        OPEX_retrofit_45_optional_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_45_optional_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_45_optional_100(n+((m-5)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_45_optional_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_45_optional_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    CF_optional_45_95(n+((m-5)*5)) = Revenue_retrofit_45_optional_95(n+((m-5)*5)) - ...
                                        CAPEX_retrofit_45_optional_95(n+((m-5)*5)) - OPEX_retrofit_45_optional_95(n+((m-5)*5)) - VOYEX_retrofit_45_optional_95(n+((m-5)*5));
                                    
                                    CF_optional_45_100(n+((m-5)*5)) = Revenue_retrofit_45_optional_100(n+((m-5)*5)) - ...
                                        CAPEX_retrofit_45_optional_100(n+((m-5)*5)) - OPEX_retrofit_45_optional_100(n+((m-5)*5)) - VOYEX_retrofit_45_optional_100(n+((m-5)*5));
                                end
                           end
                           
                           NPV_optional_45_95 = NPV(CF_optional_45_95,d_r,10);
                           NPV_optional_45_100 = NPV(CF_optional_45_100,d_r,10);
                           
                           if NPV_optional_45_95 >= NPV_optional_45_100
                               
                                CF_retrofit_45_optional = [CF_sail_another_route_23_localreg(1,(1:10)) CF_optional_45_95];
                           
                           elseif NPV_optional_45_100 > NPV_optional_45_95
                               
                               CF_retrofit_45_optional = [CF_sail_another_route_23_localreg(1,(1:10)) CF_optional_45_100];
                           end
                           
                       end
                       
                    % Optional retrofit for local zero-emission zone between epoch 5-6. 
                    % (Need to check if globale zero emission regulation have been introduced before and at this epoch.) 
                       if k == 6 && l == 1 && Era_generation(k-2,19,Era) == 0 && Era_generation(k-1,19,Era) == 0 && ...
                               Era_generation(k,19,Era) == 0 && Era_generation(k-2,21,Era) == 0 && ...
                               Era_generation(k-1,21,Era) == 0 && Era_generation(k,21,Era) == 0
                            
                           for m = 6:6
                                for n = 1:5
                                    
                                    % Retrofit option (95% zero emission):
                                    % Construction year:
                                    if Era_generation(6,19,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(3,20,Era) == 0 && m == 6 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(6,19,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(3,20,Era) == 0
                                        Retrofit = 1;
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    % Retrofit option (100% zero emission):
                                    % Construction year:
                                    if m == 6 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_optional_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    CF_optional_56_95(n+((m-6)*5)) = Revenue_retrofit_56_optional_95(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) - OPEX_retrofit_56_optional_95(n+((m-6)*5)) - VOYEX_retrofit_56_optional_95(n+((m-6)*5));
            
                                    CF_optional_56_100(n+((m-6)*5)) = Revenue_retrofit_56_optional_100(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) - OPEX_retrofit_56_optional_100(n+((m-6)*5)) - VOYEX_retrofit_56_optional_100(n+((m-6)*5));
                                end
                           end
                            
                           NPV_optional_56_95 = NPV(CF_optional_56_95,d_r,5);
                           NPV_optional_56_100 = NPV(CF_optional_56_100,d_r,5);
                           
                           if NPV_optional_56_95 >= NPV_optional_56_100
                               CF_retrofit_56_optional = [CF_sail_another_route_23_localreg(1,(1:15)) CF_optional_56_95];
                               
                           elseif NPV_optional_56_100 > NPV_optional_56_95
                               CF_retrofit_56_optional = [CF_sail_another_route_23_localreg(1,(1:15)) CF_optional_56_100];
                           end
                       end
                       
                    % Sell option: 
                    if k == 3 && l == 1
                        Retrofit = 0;
                        CAPEX_sell_23_localreg(l+((k-3)*5)) = 0; 
                        OPEX_sell_23_localreg(l+((k-3)*5)) = 0;
                        VOYEX_sell_23_localreg(l+((k-3)*5)) = 0;
                        Revenue_sell_23_localreg(l+((k-3)*5)) = Sell(k,Era,Era_generation,Ship_design) - Loan_balance(k,l,Ship_design);
                    else
                        Retrofit = 0;
                        CAPEX_sell_23_localreg(l+((k-3)*5)) = 0; 
                        OPEX_sell_23_localreg(l+((k-3)*5)) = 0;
                        VOYEX_sell_23_localreg(l+((k-3)*5)) = 0;
                        Revenue_sell_23_localreg(l+((k-3)*5)) = 0;    
                    end
                    
                    
                    CF_retrofit_23_localreg_95(l+((k-3)*5)) = Revenue_retrofit_23_localreg_95(l+((k-3)*5)) - ...
                        CAPEX_retrofit_23_localreg_95(l+((k-3)*5)) - OPEX_retrofit_23_localreg_95(l+((k-3)*5)) - VOYEX_retrofit_23_localreg_95(l+((k-3)*5));
                    
                    CF_retrofit_23_localreg_100(l+((k-3)*5)) = Revenue_retrofit_23_localreg_100(l+((k-3)*5)) - ...
                        CAPEX_retrofit_23_localreg_100(l+((k-3)*5)) - OPEX_retrofit_23_localreg_100(l+((k-3)*5)) - VOYEX_retrofit_23_localreg_100(l+((k-3)*5));
                    
                    CF_sail_another_route_23_localreg(l+((k-3)*5)) = Revenue_sail_another_route_23_localreg(l+((k-3)*5)) - ...
                        CAPEX_sail_another_route_23_localreg(l+((k-3)*5)) - OPEX_sail_another_route_23_localreg(l+((k-3)*5)) - VOYEX_sail_another_route_23_localreg(l+((k-3)*5));
                    
                    CF_sell_23_localreg(l+((k-3)*5)) = Revenue_sell_23_localreg(l+((k-3)*5)) - ...
                        CAPEX_sell_23_localreg(l+((k-3)*5)) - OPEX_sell_23_localreg(l+((k-3)*5)) - VOYEX_sell_23_localreg(l+((k-3)*5));   
                end
           end
                
                % NPV from year 5-30: Retrofit, sail another route or sell.
                NPV_retrofit_23_localreg_95 = NPV(CF_retrofit_23_localreg_95,d_r,20);
                NPV_retrofit_23_localreg_100 = NPV(CF_retrofit_23_localreg_100,d_r,20);
                
                % If no global regualtions are introduced. 
                if Era_generation(4,19,Era) == 0 && Era_generation(5,19,Era) == 0 && Era_generation(6,19,Era) == 0 && ...
                        Era_generation(4,21,Era) == 0 && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0
                    NPV_sail_another_route_23_localreg = NPV(CF_sail_another_route_23_localreg,d_r,20); % No retrofits, just sailing another route the whole time.  
                else
                    NPV_sail_another_route_23_localreg = 0;
                end
                
                NPV_sell_23_localreg = NPV(CF_sell_23_localreg,d_r,20);
                
                % NPV from year 5-30: Sail another route including global regulations at a later point in time. 
                NPV_sail_another_route_localreg_23_globalreg_34 = NPV(CF_sail_another_route_localreg_23_globalreg_34,d_r,20);
                NPV_sail_another_route_localreg_23_globalreg_45 = NPV(CF_sail_another_route_localreg_23_globalreg_45,d_r,20);
                NPV_sail_another_route_localreg_23_globalreg_56 = NPV(CF_sail_another_route_localreg_23_globalreg_56,d_r,20);
                
                % Optional retrofit for zero-emission compliance. 
                NPV_retrofit_34_optional = NPV(CF_retrofit_34_optional,d_r,20);
                NPV_retrofit_45_optional = NPV(CF_retrofit_45_optional,d_r,20);
                NPV_retrofit_56_optional = NPV(CF_retrofit_56_optional,d_r,20);
                
                % Collecting the 11 NPV values into one vector: 
                NPV_vector = [NPV_retrofit_23_localreg_95 NPV_retrofit_23_localreg_100 NPV_sail_another_route_23_localreg ...
                    NPV_sell_23_localreg NPV_sail_another_route_localreg_23_globalreg_34 ...
                    NPV_sail_another_route_localreg_23_globalreg_45 NPV_sail_another_route_localreg_23_globalreg_56 ...
                    NPV_retrofit_34_optional NPV_retrofit_45_optional NPV_retrofit_56_optional];
                
                % Select the one that maximises the NPV value for the rest
                % of the lifetime of the ship. 
                if max(NPV_vector) == NPV_vector(1)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_retrofit_23_localreg_95];
                        
                elseif max(NPV_vector) == NPV_vector(2)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_retrofit_23_localreg_100];
                    
                elseif max(NPV_vector) == NPV_vector(3)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_sail_another_route_23_localreg];
                    
                elseif max(NPV_vector) == NPV_vector(4)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_sell_23_localreg];
                
                elseif max(NPV_vector) == NPV_vector(5)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_sail_another_route_localreg_23_globalreg_34];
                    
                elseif max(NPV_vector) == NPV_vector(6)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_sail_another_route_localreg_23_globalreg_45];
                    
                elseif max(NPV_vector) == NPV_vector(7)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_sail_another_route_localreg_23_globalreg_56];
                    
                elseif max(NPV_vector) == NPV_vector(8)    
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_retrofit_34_optional];
                    
                elseif max(NPV_vector) == NPV_vector(9)    
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_retrofit_45_optional];
                    
                elseif max(NPV_vector) == NPV_vector(10)    
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:10)) CF_retrofit_56_optional];
    
                end
               finishNow = true;         
        end

        % Terminates the inner for-loop
        if finishNow 
        break
        end
    
    % Terminates the outer for-loop
    if finishNow
    break
    end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Epoch 3 -> 4
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        % Check for global zero-emission regulation
        % Check if global zero-emission regulation occurs between epoch 3-4.
        
        if (Era_generation(i,19,Era) == 1 && i == 4 && j == 1) || (Era_generation(i,21,Era) == 1 && i == 4 && j == 1)
            
            for k = 4:6
                for l = 1:5
            
                    % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!) 
                    % The fuels are here assumed as drop-in fuelsNo CAPEX cost for retrofit is assumed,
                    if Era_generation(k,19,Era) == 1 && k == 4 && l == 1
                        Retrofit = 1;
                        Shipyard = 1;
                        CAPEX_retrofit_34_globalreg_95(l+((k-4)*5)) = CAPEX_retrofit_ammonia + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_34_globalreg_95(l+((k-4)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_34_globalreg_95(l+((k-4)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_34_globalreg_95(l+((k-4)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    elseif Era_generation(k,19,Era) == 1
                        Retrofit = 1;
                        CAPEX_retrofit_34_globalreg_95(l+((k-4)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_34_globalreg_95(l+((k-4)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_34_globalreg_95(l+((k-4)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_34_globalreg_95(l+((k-4)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    
                    % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                    if k == 4 && l == 1  
                        Retrofit = 2;
                        Shipyard = 1;
                        CAPEX_retrofit_34_globalreg_100(l+((k-4)*5)) = CAPEX_retrofit_hydrogen + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_34_globalreg_100(l+((k-4)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_34_globalreg_100(l+((k-4)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_34_globalreg_100(l+((k-4)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    else
                        Retrofit = 2;
                        Hydrogen = 1;
                        CAPEX_retrofit_34_globalreg_100(l+((k-4)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_34_globalreg_100(l+((k-4)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_34_globalreg_100(l+((k-4)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_34_globalreg_100(l+((k-4)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    

                    % Sell option: 
                    if k == 4 && l == 1
                        Retrofit = 0;
                        CAPEX_sell_34_globalreg(l+((k-4)*5)) = 0;
                        OPEX_sell_34_globalreg(l+((k-4)*5)) = 0;
                        VOYEX_sell_34_globalreg(l+((k-4)*5)) = 0;
                        Revenue_sell_34_globalreg(l+((k-4)*5)) = Sell(k,Era,Era_generation,Ship_design) - Loan_balance(k,l,Ship_design);
                    else
                        Retrofit = 0;
                        CAPEX_sell_34_globalreg(l+((k-4)*5)) = 0; 
                        OPEX_sell_34_globalreg(l+((k-4)*5)) = 0;
                        VOYEX_sell_34_globalreg(l+((k-4)*5)) = 0;
                        Revenue_sell_34_globalreg(l+((k-4)*5)) = 0;    
                    end
            
                    CF_retrofit_34_globalreg_95(l+((k-4)*5)) = Revenue_retrofit_34_globalreg_95(l+((k-4)*5)) - ...
                        CAPEX_retrofit_34_globalreg_95(l+((k-4)*5)) - OPEX_retrofit_34_globalreg_95(l+((k-4)*5)) - VOYEX_retrofit_34_globalreg_95(l+((k-4)*5));
                    
                    CF_retrofit_34_globalreg_100(l+((k-4)*5)) = Revenue_retrofit_34_globalreg_100(l+((k-4)*5)) - ...
                        CAPEX_retrofit_34_globalreg_100(l+((k-4)*5)) - OPEX_retrofit_34_globalreg_100(l+((k-4)*5)) - VOYEX_retrofit_34_globalreg_100(l+((k-4)*5));
            
                    CF_sell_34_globalreg(l+((k-4)*5)) = Revenue_sell_34_globalreg(l+((k-4)*5)) - ...
                        CAPEX_sell_34_globalreg(l+((k-4)*5)) - OPEX_sell_34_globalreg(l+((k-4)*5)) - VOYEX_sell_34_globalreg(l+((k-4)*5));
            
                end
            end
            
            NPV_retrofit_34_globalreg_95 = NPV(CF_retrofit_34_globalreg_95,d_r,15);
            NPV_retrofit_34_globalreg_100 = NPV(CF_retrofit_34_globalreg_100,d_r,15);
            NPV_sell_34_globalreg = NPV(CF_sell_34_globalreg,d_r,15);
            
            if NPV_retrofit_34_globalreg_95 >= NPV_sell_34_globalreg && NPV_retrofit_34_globalreg_95 >= NPV_retrofit_34_globalreg_100
                
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:15)) CF_retrofit_34_globalreg_95];
                
            elseif NPV_retrofit_34_globalreg_100 >= NPV_sell_34_globalreg && NPV_retrofit_34_globalreg_100 >= NPV_retrofit_34_globalreg_95
                
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:15)) CF_retrofit_34_globalreg_100];     
                
            elseif NPV_sell_34_globalreg >= NPV_retrofit_34_globalreg_95 && NPV_sell_34_globalreg >= NPV_retrofit_34_globalreg_100
  
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:15)) CF_sell_34_globalreg];
            
            end
            finishNow = true;
        end
        % Terminates the inner for-loop
        if finishNow 
        break
        end
    
    
    % Terminates the outer for-loop
    if finishNow
    break
    end

    
    
    % Check if local zero-emission regulation occurs between epoch 3-4.
        
        if (Era_generation(i,18,Era) == 1 && i == 4 && j == 1) || (Era_generation(i,20,Era) == 1 && i == 4 && j == 1)
            
           for k = 4:6
                for l = 1:5
            
                    % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future 95% zero emission zones also!)
                    if Era_generation(i,18,Era) == 1 && k == 4 && l == 1
                        Retrofit = 1;
                        Shipyard = 1;
                        CAPEX_retrofit_34_localreg_95(l+((k-4)*5)) = CAPEX_retrofit_ammonia + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_34_localreg_95(l+((k-4)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_34_localreg_95(l+((k-4)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                        Revenue_retrofit_34_localreg_95(l+((k-4)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    elseif Era_generation(i,18,Era) == 1
                        Retrofit = 1;
                        CAPEX_retrofit_34_localreg_95(l+((k-4)*5)) = CAPEX(k,l,Ship_design);
                        OPEX_retrofit_34_localreg_95(l+((k-4)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_34_localreg_95(l+((k-4)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_34_localreg_95(l+((k-4)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);    
                    end

                    % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future 100% zero emission zones also!)
                    % Construction year:
                    if k == 4 && l == 1  
                        Retrofit = 2;
                        Shipyard = 1;
                        CAPEX_retrofit_34_localreg_100(l+((k-4)*5)) = CAPEX_retrofit_hydrogen + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_34_localreg_100(l+((k-4)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_34_localreg_100(l+((k-4)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                        Revenue_retrofit_34_localreg_100(l+((k-4)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    else
                        Retrofit = 2;
                        Hydrogen = 1;
                        CAPEX_retrofit_34_localreg_100(l+((k-4)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_34_localreg_100(l+((k-4)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_34_localreg_100(l+((k-4)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_34_localreg_100(l+((k-4)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    
                    % Sail another route option:
                    % Calculate for epoch 3,4,5,6 (depending on "global zero-emission" is introduced or not) 
                    Retrofit = 0;
                    CAPEX_sail_another_route_34_localreg(l+((k-4)*5)) = CAPEX(k,l,Ship_design); 
                    OPEX_sail_another_route_34_localreg(l+((k-4)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                    VOYEX_sail_another_route_34_localreg(l+((k-4)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                    Revenue_sail_another_route_34_localreg(l+((k-4)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard) - (Revenue(k,l,Retrofit,Ship_design,Shipyard)*Revenue_time_loss); % loss in revenue 
                    
                    
                    % Need to check if a global regulation is introduced between epoch 4-5.
                       if (Era_generation(k,19,Era) == 1 && k == 5 && l == 1 && Global_regulation == 0) || (Era_generation(k,21,Era) == 1 && k == 5 && l == 1 && Global_regulation == 0)
                            
                           for m = 5:6
                                for n = 1:5
                                
                                % Have to either retrofit or sell!    
                                
                                % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                if Era_generation(m,19,Era) == 1 && m == 5 && n == 1 
                                    Retrofit = 1;
                                    Shipyard = 1;
                                    CAPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_45_globalreg_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                elseif Era_generation(m,19,Era) == 1
                                    Retrofit = 1;
                                    CAPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_45_globalreg_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);  
                                    Revenue_retrofit_45_globalreg_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end
                                
                                % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                % Construction year:
                                if m == 5 && n == 1  
                                    Retrofit = 2;
                                    Shipyard = 1;
                                    CAPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                    Revenue_retrofit_45_globalreg_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                else
                                    Retrofit = 2;
                                    Hydrogen = 1;
                                    CAPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = CAPEX(m,n,Ship_design); 
                                    OPEX_retrofit_45_globalreg_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                    VOYEX_retrofit_45_globalreg_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                    Revenue_retrofit_45_globalreg_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                end

                                % Sell option: 
                                if m == 5 && n == 1
                                    Retrofit = 0;
                                    CAPEX_sell_45_globalreg(n+((m-5)*5)) = 0; 
                                    OPEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    VOYEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    Revenue_sell_45_globalreg(n+((m-5)*5)) = Sell(m,Era,Era_generation,Ship_design) - Loan_balance(m,n,Ship_design);
                                else
                                    Retrofit = 0;
                                    CAPEX_sell_45_globalreg(n+((m-5)*5)) = 0; 
                                    OPEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    VOYEX_sell_45_globalreg(n+((m-5)*5)) = 0;
                                    Revenue_sell_45_globalreg(n+((m-5)*5)) = 0;    
                                end
            
                                CF_retrofit_45_globalreg_95(n+((m-5)*5)) = Revenue_retrofit_45_globalreg_95(n+((m-5)*5)) - ...
                                    CAPEX_retrofit_45_globalreg_95(n+((m-5)*5)) - OPEX_retrofit_45_globalreg_95(n+((m-5)*5)) - VOYEX_retrofit_45_globalreg_95(n+((m-5)*5));
                                
                                CF_retrofit_45_globalreg_100(n+((m-5)*5)) = Revenue_retrofit_45_globalreg_100(n+((m-5)*5)) - ...
                                    CAPEX_retrofit_45_globalreg_100(n+((m-5)*5)) - OPEX_retrofit_45_globalreg_100(n+((m-5)*5)) - VOYEX_retrofit_45_globalreg_100(n+((m-5)*5));
                                
                                CF_sell_45_globalreg(n+((m-5)*5)) = Revenue_sell_45_globalreg(n+((m-5)*5)) - ...
                                    CAPEX_sell_45_globalreg(n+((m-5)*5)) - OPEX_sell_45_globalreg(n+((m-5)*5)) - VOYEX_sell_45_globalreg(n+((m-5)*5));
            
                                end
                           end
                       

                           NPV_retrofit_45_globalreg_95 = NPV(CF_retrofit_45_globalreg_95,d_r,10);
                           NPV_retrofit_45_globalreg_100 = NPV(CF_retrofit_45_globalreg_100,d_r,10);
                           NPV_sell_45_globalreg = NPV(CF_sell_45_globalreg,d_r,10);
            
                           if NPV_retrofit_45_globalreg_95 >= NPV_sell_45_globalreg && NPV_retrofit_45_globalreg_95 >= NPV_retrofit_45_globalreg_100
                
                                CF_sail_another_route_localreg_34_globalreg_45 = [CF_sail_another_route_34_localreg(1,(1:5)) CF_retrofit_45_globalreg_95];
                                
                           elseif NPV_retrofit_45_globalreg_100 >= NPV_sell_45_globalreg && NPV_retrofit_45_globalreg_100 >= NPV_retrofit_45_globalreg_95
                
                                CF_sail_another_route_localreg_34_globalreg_45 = [CF_sail_another_route_34_localreg(1,(1:5)) CF_retrofit_45_globalreg_100];     
                                
                           elseif NPV_sell_45_globalreg >= NPV_retrofit_45_globalreg_95 && NPV_sell_45_globalreg >= NPV_retrofit_45_globalreg_100
            
                                CF_sail_another_route_localreg_34_globalreg_45 = [CF_sail_another_route_34_localreg(1,(1:5)) CF_sell_45_globalreg];
                           end
                           Global_regulation = 1;
                        end 
                       
                    % Need to check if a global regulation is introduced between epoch 5-6.
                       if (Era_generation(k,19,Era) == 1 && k == 6 && l == 1 && Global_regulation == 0) || (Era_generation(k,21,Era) == 1 && k == 6 && l == 1 && Global_regulation == 0)
                            
                           for m = 6:6
                                for n = 1:5
                                
                                    % Have to either retrofit or sell!    
                                    
                                    % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                    if Era_generation(m,19,Era) == 1 && m == 6 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design);
                                        OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(m,19,Era) == 1
                                        Retrofit = 1;
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                    % Construction year:
                                    if m == 6 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    % Sell option: 
                                    if m == 6 && n == 1
                                        Retrofit = 0;
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) = 0; 
                                        OPEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        VOYEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        Revenue_sell_56_globalreg(n+((m-6)*5)) = Sell(m,Era,Era_generation,Ship_design) - Loan_balance(m,n,Ship_design);
                                    else
                                        Retrofit = 0;
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) = 0; 
                                        OPEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        VOYEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        Revenue_sell_56_globalreg(n+((m-6)*5)) = 0;    
                                    end
            
                                    CF_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) - OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) - VOYEX_retrofit_56_globalreg_95(n+((m-6)*5));
                                    
                                    CF_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) - OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) - VOYEX_retrofit_56_globalreg_100(n+((m-6)*5));
                                    
                                    CF_sell_56_globalreg(n+((m-6)*5)) = Revenue_sell_56_globalreg(n+((m-6)*5)) - ...
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) - OPEX_sell_56_globalreg(n+((m-6)*5)) - VOYEX_sell_56_globalreg(n+((m-6)*5));
            
                                end
                           end
            
                           NPV_retrofit_56_globalreg_95 = NPV(CF_retrofit_56_globalreg_95,d_r,5);
                           NPV_retrofit_56_globalreg_100 = NPV(CF_retrofit_56_globalreg_100,d_r,5);
                           NPV_sell_56_globalreg = NPV(CF_sell_56_globalreg,d_r,5);
            
                           if NPV_retrofit_56_globalreg_95 >= NPV_sell_56_globalreg && NPV_retrofit_56_globalreg_95 >= NPV_retrofit_56_globalreg_100
                
                                CF_sail_another_route_localreg_34_globalreg_56 = [CF_sail_another_route_34_localreg(1,(1:10)) CF_retrofit_56_globalreg_95];
                                
                           elseif NPV_retrofit_56_globalreg_100 >= NPV_sell_56_globalreg && NPV_retrofit_56_globalreg_100 >= NPV_retrofit_56_globalreg_95
                
                                CF_sail_another_route_localreg_34_globalreg_56 = [CF_sail_another_route_34_localreg(1,(1:10)) CF_retrofit_56_globalreg_100];     
                                
                           elseif NPV_sell_56_globalreg >= NPV_retrofit_56_globalreg_95 && NPV_sell_56_globalreg >= NPV_retrofit_56_globalreg_100
            
                                CF_sail_another_route_localreg_34_globalreg_56 = [CF_sail_another_route_34_localreg(1,(1:10)) CF_sell_56_globalreg];
                           end
                           Global_regulation = 1;
                       end   
                       
                    
                    % The option to make a retrofit eventhough the regulation is not requiering it.

                    % Optional retrofit for local zero-emission zone between epoch 4-5. 
                    % (Need to check if globale zero emission regulation have been introduced before and at this epoch.)  
                       if k == 5 && l == 1 && Era_generation(k,19,Era) == 0 && Era_generation(k,21,Era) == 0
                        
                           for m = 5:6
                                for n = 1:5
     
                                    % Retrofit option (95% zero emission):
                                    if Era_generation(5,19,Era) == 0 && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 ...
                                            && Era_generation(4,20,Era) == 0 && m == 5 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_45_optional_95(n+((m-5)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_45_optional_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_45_optional_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(5,19,Era) == 0 && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 ...
                                            && Era_generation(4,20,Era) == 0
                                        Retrofit = 1;
                                        CAPEX_retrofit_45_optional_95(n+((m-5)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_45_optional_95(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_95(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_45_optional_95(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    
                                    % Retrofit option (100% zero emission):
                                    % Construction year:
                                    if m == 5 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_45_optional_100(n+((m-5)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_45_optional_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_45_optional_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_45_optional_100(n+((m-5)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_45_optional_100(n+((m-5)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_45_optional_100(n+((m-5)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_45_optional_100(n+((m-5)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    CF_optional_45_95(n+((m-5)*5)) = Revenue_retrofit_45_optional_95(n+((m-5)*5)) - ...
                                        CAPEX_retrofit_45_optional_95(n+((m-5)*5)) - OPEX_retrofit_45_optional_95(n+((m-5)*5)) - VOYEX_retrofit_45_optional_95(n+((m-5)*5));
                                    
                                    CF_optional_45_100(n+((m-5)*5)) = Revenue_retrofit_45_optional_100(n+((m-5)*5)) - ...
                                        CAPEX_retrofit_45_optional_100(n+((m-5)*5)) - OPEX_retrofit_45_optional_100(n+((m-5)*5)) - VOYEX_retrofit_45_optional_100(n+((m-5)*5));
                                end
                           end
                           
                           NPV_optional_45_95 = NPV(CF_optional_45_95,d_r,10);
                           NPV_optional_45_100 = NPV(CF_optional_45_100,d_r,10);
                           
                           if NPV_optional_45_95 >= NPV_optional_45_100
                               
                                CF_retrofit_45_optional = [CF_sail_another_route_34_localreg(1,(1:5)) CF_optional_45_95];
                           
                           elseif NPV_optional_45_100 > NPV_optional_45_95
                               
                               CF_retrofit_45_optional = [CF_sail_another_route_34_localreg(1,(1:5)) CF_optional_45_100];
                           end
                           
                       end
                       
                    % Optional retrofit for local zero-emission zone between epoch 5-6. 
                    % (Need to check if globale zero emission regulation have been introduced before and at this epoch.) 
                       if k == 6 && l == 1 && Era_generation(k-1,19,Era) == 0 && Era_generation(k,19,Era) == 0 ...
                               && Era_generation(k-1,21,Era) == 0 && Era_generation(k,21,Era) == 0
                            
                           for m = 6:6
                                for n = 1:5
                                    
                                    % Retrofit option (95% zero emission):
                                    % Construction year:
                                    if Era_generation(6,19,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(4,20,Era) == 0 && m == 6 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_optional_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(6,19,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(4,20,Era) == 0
                                        Retrofit = 1;
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design);
                                    end
                                    
                                    % Retrofit option (100% zero emission):
                                    % Construction year:
                                    if m == 6 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    CF_optional_56_95(n+((m-6)*5)) = Revenue_retrofit_56_optional_95(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) - OPEX_retrofit_56_optional_95(n+((m-6)*5)) - VOYEX_retrofit_56_optional_95(n+((m-6)*5));
            
                                    CF_optional_56_100(n+((m-6)*5)) = Revenue_retrofit_56_optional_100(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) - OPEX_retrofit_56_optional_100(n+((m-6)*5)) - VOYEX_retrofit_56_optional_100(n+((m-6)*5));
                                end
                           end
                            
                           NPV_optional_56_95 = NPV(CF_optional_56_95,d_r,5);
                           NPV_optional_56_100 = NPV(CF_optional_56_100,d_r,5);
                           
                           if NPV_optional_56_95 >= NPV_optional_56_100
                               CF_retrofit_56_optional = [CF_sail_another_route_34_localreg(1,(1:10)) CF_optional_56_95];
                               
                           elseif NPV_optional_56_100 > NPV_optional_56_95
                               CF_retrofit_56_optional = [CF_sail_another_route_34_localreg(1,(1:10)) CF_optional_56_100];
                           end
                       end
                       
                    % Sell option: 
                    if k == 4 && l == 1
                        Retrofit = 0;
                        CAPEX_sell_34_localreg(l+((k-4)*5)) = 0; 
                        OPEX_sell_34_localreg(l+((k-4)*5)) = 0;
                        VOYEX_sell_34_localreg(l+((k-4)*5)) = 0;
                        Revenue_sell_34_localreg(l+((k-4)*5)) = Sell(k,Era,Era_generation,Ship_design) - Loan_balance(k,l,Ship_design);
                    else
                        Retrofit = 0;
                        CAPEX_sell_34_localreg(l+((k-4)*5)) = 0; 
                        OPEX_sell_34_localreg(l+((k-4)*5)) = 0;
                        VOYEX_sell_34_localreg(l+((k-4)*5)) = 0;
                        Revenue_sell_34_localreg(l+((k-4)*5)) = 0;    
                    end
                    
                    
                    CF_retrofit_34_localreg_95(l+((k-4)*5)) = Revenue_retrofit_34_localreg_95(l+((k-4)*5)) - ...
                        CAPEX_retrofit_34_localreg_95(l+((k-4)*5)) - OPEX_retrofit_34_localreg_95(l+((k-4)*5)) - VOYEX_retrofit_34_localreg_95(l+((k-4)*5));
                    
                    CF_retrofit_34_localreg_100(l+((k-4)*5)) = Revenue_retrofit_34_localreg_100(l+((k-4)*5)) - ...
                        CAPEX_retrofit_34_localreg_100(l+((k-4)*5)) - OPEX_retrofit_34_localreg_100(l+((k-4)*5)) - VOYEX_retrofit_34_localreg_100(l+((k-4)*5));
                    
                    CF_sail_another_route_34_localreg(l+((k-4)*5)) = Revenue_sail_another_route_34_localreg(l+((k-4)*5)) - ...
                        CAPEX_sail_another_route_34_localreg(l+((k-4)*5)) - OPEX_sail_another_route_34_localreg(l+((k-4)*5)) - VOYEX_sail_another_route_34_localreg(l+((k-4)*5));
                    
                    CF_sell_34_localreg(l+((k-4)*5)) = Revenue_sell_34_localreg(l+((k-4)*5)) - ...
                        CAPEX_sell_34_localreg(l+((k-4)*5)) - OPEX_sell_34_localreg(l+((k-4)*5)) - VOYEX_sell_34_localreg(l+((k-4)*5));   
                end
           end
                
                % NPV from year 5-30: Retrofit, sail another route or sell.
                NPV_retrofit_34_localreg_95 = NPV(CF_retrofit_34_localreg_95,d_r,15);
                NPV_retrofit_34_localreg_100 = NPV(CF_retrofit_34_localreg_100,d_r,15);
                
                % If no global regualtions are introduced. 
                if Era_generation(5,19,Era) == 0 && Era_generation(6,19,Era) == 0 && ...
                        Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0
                    NPV_sail_another_route_34_localreg = NPV(CF_sail_another_route_34_localreg,d_r,15); % No retrofits, just sailing another route the whole time.  
                else
                    NPV_sail_another_route_34_localreg = 0;
                end
                
                NPV_sell_34_localreg = NPV(CF_sell_34_localreg,d_r,15);
                
                % NPV from year 5-30: Sail another route including global regulations at a later point in time. 
                NPV_sail_another_route_localreg_34_globalreg_45 = NPV(CF_sail_another_route_localreg_34_globalreg_45,d_r,15);
                NPV_sail_another_route_localreg_34_globalreg_56 = NPV(CF_sail_another_route_localreg_34_globalreg_56,d_r,15);
                
                % Optional retrofit for zero-emission compliance. 
                NPV_retrofit_45_optional = NPV(CF_retrofit_45_optional,d_r,15);
                NPV_retrofit_56_optional = NPV(CF_retrofit_56_optional,d_r,15);
                
                % Collecting the 11 NPV values into one vector: 
                NPV_vector = [NPV_retrofit_34_localreg_95 NPV_retrofit_34_localreg_100 NPV_sail_another_route_34_localreg ...
                    NPV_sell_34_localreg NPV_sail_another_route_localreg_34_globalreg_45 NPV_sail_another_route_localreg_34_globalreg_56 ...
                    NPV_retrofit_45_optional NPV_retrofit_56_optional];
                
                % Select the one that maximises the NPV value for the rest
                % of the lifetime of the ship. 
                if max(NPV_vector) == NPV_vector(1)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:15)) CF_retrofit_34_localreg_95];
                    
                elseif max(NPV_vector) == NPV_vector(2)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:15)) CF_retrofit_34_localreg_100];
                    
                elseif max(NPV_vector) == NPV_vector(3)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:15)) CF_sail_another_route_34_localreg];
                    
                elseif max(NPV_vector) == NPV_vector(4)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:15)) CF_sell_34_localreg];
                
                elseif max(NPV_vector) == NPV_vector(5)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:15)) CF_sail_another_route_localreg_34_globalreg_45];
                    

                elseif max(NPV_vector) == NPV_vector(6)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:15)) CF_sail_another_route_localreg_34_globalreg_56];

                    
                elseif max(NPV_vector) == NPV_vector(7)    
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:15)) CF_retrofit_45_optional];

                elseif max(NPV_vector) == NPV_vector(8)    
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:15)) CF_retrofit_56_optional];
                    
                end
               finishNow = true;         
        end

        % Terminates the inner for-loop
        if finishNow 
        break
        end
    
    % Terminates the outer for-loop
    if finishNow
    break
    end
    


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Epoch 4 -> 5
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        % Check for global zero-emission regulation
        % Check if global zero-emission regulation occurs between epoch 4-5.
        
        if (Era_generation(i,19,Era) == 1 && i == 5 && j == 1) || (Era_generation(i,21,Era) == 1 && i == 5 && j == 1)
            
            for k = 5:6
                for l = 1:5
            
                    % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!) 
                    % The fuels are here assumed as drop-in fuelsNo CAPEX cost for retrofit is assumed,
                    if Era_generation(k,19,Era) == 1 && k == 5 && l == 1
                        Retrofit = 1;
                        Shipyard = 1;
                        CAPEX_retrofit_45_globalreg_95(l+((k-5)*5)) = CAPEX_retrofit_ammonia + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_45_globalreg_95(l+((k-5)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_45_globalreg_95(l+((k-5)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_45_globalreg_95(l+((k-5)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    elseif Era_generation(k,19,Era) == 1
                        Retrofit = 1;
                        CAPEX_retrofit_45_globalreg_95(l+((k-5)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_45_globalreg_95(l+((k-5)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_45_globalreg_95(l+((k-5)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_45_globalreg_95(l+((k-5)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    
                    % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                    if k == 5 && l == 1  
                        Retrofit = 2;
                        Shipyard = 1;
                        CAPEX_retrofit_45_globalreg_100(l+((k-5)*5)) = CAPEX_retrofit_hydrogen + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_45_globalreg_100(l+((k-5)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_45_globalreg_100(l+((k-5)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                        Revenue_retrofit_45_globalreg_100(l+((k-5)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    else
                        Retrofit = 2;
                        Hydrogen = 1;
                        CAPEX_retrofit_45_globalreg_100(l+((k-5)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_45_globalreg_100(l+((k-5)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_45_globalreg_100(l+((k-5)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_45_globalreg_100(l+((k-5)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    

                    % Sell option: 
                    if k == 5 && l == 1
                        Retrofit = 0;
                        CAPEX_sell_45_globalreg(l+((k-5)*5)) = 0;
                        OPEX_sell_45_globalreg(l+((k-5)*5)) = 0;
                        VOYEX_sell_45_globalreg(l+((k-5)*5)) = 0;
                        Revenue_sell_45_globalreg(l+((k-5)*5)) = Sell(k,Era,Era_generation,Ship_design) - Loan_balance(k,l,Ship_design);
                    else
                        Retrofit = 0;
                        CAPEX_sell_45_globalreg(l+((k-5)*5)) = 0; 
                        OPEX_sell_45_globalreg(l+((k-5)*5)) = 0;
                        VOYEX_sell_45_globalreg(l+((k-5)*5)) = 0;
                        Revenue_sell_45_globalreg(l+((k-5)*5)) = 0;    
                    end
            
                    CF_retrofit_45_globalreg_95(l+((k-5)*5)) = Revenue_retrofit_45_globalreg_95(l+((k-5)*5)) - ...
                        CAPEX_retrofit_45_globalreg_95(l+((k-5)*5)) - OPEX_retrofit_45_globalreg_95(l+((k-5)*5)) - VOYEX_retrofit_45_globalreg_95(l+((k-5)*5));
                    
                    CF_retrofit_45_globalreg_100(l+((k-5)*5)) = Revenue_retrofit_45_globalreg_100(l+((k-5)*5)) - ...
                        CAPEX_retrofit_45_globalreg_100(l+((k-5)*5)) - OPEX_retrofit_45_globalreg_100(l+((k-5)*5)) - VOYEX_retrofit_45_globalreg_100(l+((k-5)*5));
            
                    CF_sell_45_globalreg(l+((k-5)*5)) = Revenue_sell_45_globalreg(l+((k-5)*5)) - ...
                        CAPEX_sell_45_globalreg(l+((k-5)*5)) - OPEX_sell_45_globalreg(l+((k-5)*5)) - VOYEX_sell_45_globalreg(l+((k-5)*5));
            
                end
            end
            
            NPV_retrofit_45_globalreg_95 = NPV(CF_retrofit_45_globalreg_95,d_r,10);
            NPV_retrofit_45_globalreg_100 = NPV(CF_retrofit_45_globalreg_100,d_r,10);
            NPV_sell_45_globalreg = NPV(CF_sell_45_globalreg,d_r,10);
            
            if NPV_retrofit_45_globalreg_95 >= NPV_sell_45_globalreg && NPV_retrofit_45_globalreg_95 >= NPV_retrofit_45_globalreg_100
                
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:20)) CF_retrofit_45_globalreg_95];
                
            elseif NPV_retrofit_45_globalreg_100 >= NPV_sell_45_globalreg && NPV_retrofit_45_globalreg_100 >= NPV_retrofit_45_globalreg_95
                
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:20)) CF_retrofit_45_globalreg_100];     
                
            elseif NPV_sell_45_globalreg >= NPV_retrofit_45_globalreg_95 && NPV_sell_45_globalreg >= NPV_retrofit_45_globalreg_100
  
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:20)) CF_sell_45_globalreg];
            
            end
            finishNow = true;
        end
        % Terminates the inner for-loop
        if finishNow 
        break
        end
    
    
    % Terminates the outer for-loop
    if finishNow
    break
    end


    % Check if local zero-emission regulation occurs between epoch 4-5.
        
        if (Era_generation(i,18,Era) == 1 && i == 5 && j == 1) || (Era_generation(i,20,Era) == 1 && i == 5 && j == 1)
            
           for k = 5:6
                for l = 1:5
            
                    % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future 95% zero emission zones also!)
                    if Era_generation(i,18,Era) == 1 && k == 5 && l == 1
                        Retrofit = 1;
                        Shipyard = 1;
                        CAPEX_retrofit_45_localreg_95(l+((k-5)*5)) = CAPEX_retrofit_ammonia + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_45_localreg_95(l+((k-5)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_45_localreg_95(l+((k-5)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_45_localreg_95(l+((k-5)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    elseif Era_generation(i,18,Era) == 1
                        Retrofit = 1;
                        CAPEX_retrofit_45_localreg_95(l+((k-5)*5)) = CAPEX(k,l,Ship_design);
                        OPEX_retrofit_45_localreg_95(l+((k-5)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_45_localreg_95(l+((k-5)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_45_localreg_95(l+((k-5)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);    
                    end

                    % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future 100% zero emission zones also!)
                    % Construction year:
                    if k == 5 && l == 1  
                        Retrofit = 2;
                        Shipyard = 1;
                        CAPEX_retrofit_45_localreg_100(l+((k-5)*5)) = CAPEX_retrofit_hydrogen + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_45_localreg_100(l+((k-5)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_45_localreg_100(l+((k-5)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_45_localreg_100(l+((k-5)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    else
                        Retrofit = 2;
                        Hydrogen = 1;
                        CAPEX_retrofit_45_localreg_100(l+((k-5)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_45_localreg_100(l+((k-5)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_45_localreg_100(l+((k-5)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_45_localreg_100(l+((k-5)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    
                    % Sail another route option:
                    % Calculate for epoch 5,6 (depending on "global zero-emission" is introduced or not) 
                    Retrofit = 0;
                    CAPEX_sail_another_route_45_localreg(l+((k-5)*5)) = CAPEX(k,l,Ship_design); 
                    OPEX_sail_another_route_45_localreg(l+((k-5)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                    VOYEX_sail_another_route_45_localreg(l+((k-5)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                    Revenue_sail_another_route_45_localreg(l+((k-5)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard) - (Revenue(k,l,Retrofit,Ship_design,Shipyard)*Revenue_time_loss); % loss in revenue 
                    
                       
                    % Need to check if a global regulation is introduced between epoch 5-6.
                       if (Era_generation(k,19,Era) == 1 && k == 6 && l == 1 && Global_regulation == 0) || (Era_generation(k,21,Era) == 1 && k == 6 && l == 1 && Global_regulation == 0)
                            
                           for m = 6:6
                                for n = 1:5
                                
                                    % Have to either retrofit or sell!    
                                    
                                    % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                    if Era_generation(m,19,Era) == 1 && m == 6 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(m,19,Era) == 1
                                        Retrofit = 1;
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    % Retrofit option: (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                                    % Construction year:
                                    if m == 6 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design);
                                        OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = CAPEX(m,n,Ship_design);
                                        OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_globalreg_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss);
                                        Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    % Sell option: 
                                    if m == 6 && n == 1
                                        Retrofit = 0;
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) = 0; 
                                        OPEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        VOYEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        Revenue_sell_56_globalreg(n+((m-6)*5)) = Sell(m,Era,Era_generation,Ship_design) - Loan_balance(m,n,Ship_design);
                                    else
                                        Retrofit = 0;
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) = 0; 
                                        OPEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        VOYEX_sell_56_globalreg(n+((m-6)*5)) = 0;
                                        Revenue_sell_56_globalreg(n+((m-6)*5)) = 0;    
                                    end
            
                                    CF_retrofit_56_globalreg_95(n+((m-6)*5)) = Revenue_retrofit_56_globalreg_95(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_globalreg_95(n+((m-6)*5)) - OPEX_retrofit_56_globalreg_95(n+((m-6)*5)) - VOYEX_retrofit_56_globalreg_95(n+((m-6)*5));
                                    
                                    CF_retrofit_56_globalreg_100(n+((m-6)*5)) = Revenue_retrofit_56_globalreg_100(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_globalreg_100(n+((m-6)*5)) - OPEX_retrofit_56_globalreg_100(n+((m-6)*5)) - VOYEX_retrofit_56_globalreg_100(n+((m-6)*5));
                                    
                                    CF_sell_56_globalreg(n+((m-6)*5)) = Revenue_sell_56_globalreg(n+((m-6)*5)) - ...
                                        CAPEX_sell_56_globalreg(n+((m-6)*5)) - OPEX_sell_56_globalreg(n+((m-6)*5)) - VOYEX_sell_56_globalreg(n+((m-6)*5));
            
                                end
                           end
            
                           NPV_retrofit_56_globalreg_95 = NPV(CF_retrofit_56_globalreg_95,d_r,5);
                           NPV_retrofit_56_globalreg_100 = NPV(CF_retrofit_56_globalreg_100,d_r,5);
                           NPV_sell_56_globalreg = NPV(CF_sell_56_globalreg,d_r,5);
            
                           if NPV_retrofit_56_globalreg_95 >= NPV_sell_56_globalreg && NPV_retrofit_56_globalreg_95 >= NPV_retrofit_56_globalreg_100
                
                                CF_sail_another_route_localreg_45_globalreg_56 = [CF_sail_another_route_45_localreg(1,(1:5)) CF_retrofit_56_globalreg_95];
                                
                           elseif NPV_retrofit_56_globalreg_100 >= NPV_sell_56_globalreg && NPV_retrofit_56_globalreg_100 >= NPV_retrofit_56_globalreg_95
                
                                CF_sail_another_route_localreg_45_globalreg_56 = [CF_sail_another_route_45_localreg(1,(1:5)) CF_retrofit_56_globalreg_100];     
                                
                           elseif NPV_sell_56_globalreg >= NPV_retrofit_56_globalreg_95 && NPV_sell_56_globalreg >= NPV_retrofit_56_globalreg_100
            
                                CF_sail_another_route_localreg_45_globalreg_56 = [CF_sail_another_route_45_localreg(1,(1:5)) CF_sell_56_globalreg];
                           end
                           Global_regulation = 1;
                       end   
                       
                    
                    % The option to make a retrofit eventhough the regulation is not requiering it.
                    
                    % Optional retrofit for local zero-emission zone between epoch 5-6. 
                    % (Need to check if globale zero emission regulation have been introduced before and at this epoch.) 
                       if k == 6 && l == 1 && Era_generation(k,19,Era) == 0 && Era_generation(k,21,Era) == 0
                            
                           for m = 6:6
                                for n = 1:5
                                    
                                    % Retrofit option (95% zero emission):
                                    % Construction year:
                                    if Era_generation(6,19,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(5,20,Era) == 0 && m == 6 && n == 1
                                        Retrofit = 1;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) = CAPEX_retrofit_ammonia + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    elseif Era_generation(6,19,Era) == 0 && Era_generation(6,21,Era) == 0 && Era_generation(5,20,Era) == 0
                                        Retrofit = 1;
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) = CAPEX(m,n,Ship_design);
                                        OPEX_retrofit_56_optional_95(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_95(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_95(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end
                                    
                                    % Retrofit option (100% zero emission):
                                    % Construction year:
                                    if m == 6 && n == 1  
                                        Retrofit = 2;
                                        Shipyard = 1;
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) = CAPEX_retrofit_hydrogen + CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    else
                                        Retrofit = 2;
                                        Hydrogen = 1;
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) = CAPEX(m,n,Ship_design); 
                                        OPEX_retrofit_56_optional_100(n+((m-6)*5)) = OPEX(m,n,Ship_design,Retrofit,Hydrogen);
                                        VOYEX_retrofit_56_optional_100(n+((m-6)*5)) = VOYEX(m,n,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                                        Revenue_retrofit_56_optional_100(n+((m-6)*5)) = Revenue(m,n,Retrofit,Ship_design,Shipyard);
                                    end

                                    CF_optional_56_95(n+((m-6)*5)) = Revenue_retrofit_56_optional_95(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_optional_95(n+((m-6)*5)) - OPEX_retrofit_56_optional_95(n+((m-6)*5)) - VOYEX_retrofit_56_optional_95(n+((m-6)*5));
            
                                    CF_optional_56_100(n+((m-6)*5)) = Revenue_retrofit_56_optional_100(n+((m-6)*5)) - ...
                                        CAPEX_retrofit_56_optional_100(n+((m-6)*5)) - OPEX_retrofit_56_optional_100(n+((m-6)*5)) - VOYEX_retrofit_56_optional_100(n+((m-6)*5));
                                end
                           end
                            
                           NPV_optional_56_95 = NPV(CF_optional_56_95,d_r,5);
                           NPV_optional_56_100 = NPV(CF_optional_56_100,d_r,5);
                           
                           if NPV_optional_56_95 >= NPV_optional_56_100
                               CF_retrofit_56_optional = [CF_sail_another_route_45_localreg(1,(1:5)) CF_optional_56_95];
                               
                           elseif NPV_optional_56_100 > NPV_optional_56_95
                               CF_retrofit_56_optional = [CF_sail_another_route_45_localreg(1,(1:5)) CF_optional_56_100];
                           end
                       end
                       
                    % Sell option: 
                    if k == 5 && l == 1
                        Retrofit = 0;
                        CAPEX_sell_45_localreg(l+((k-5)*5)) = 0; 
                        OPEX_sell_45_localreg(l+((k-5)*5)) = 0;
                        VOYEX_sell_45_localreg(l+((k-5)*5)) = 0;
                        Revenue_sell_45_localreg(l+((k-5)*5)) = Sell(k,Era,Era_generation,Ship_design) - Loan_balance(k,l,Ship_design);
                    else
                        Retrofit = 0;
                        CAPEX_sell_45_localreg(l+((k-5)*5)) = 0; 
                        OPEX_sell_45_localreg(l+((k-5)*5)) = 0;
                        VOYEX_sell_45_localreg(l+((k-5)*5)) = 0;
                        Revenue_sell_45_localreg(l+((k-5)*5)) = 0;    
                    end
                    
                    
                    CF_retrofit_45_localreg_95(l+((k-5)*5)) = Revenue_retrofit_45_localreg_95(l+((k-5)*5)) - ...
                        CAPEX_retrofit_45_localreg_95(l+((k-5)*5)) - OPEX_retrofit_45_localreg_95(l+((k-5)*5)) - VOYEX_retrofit_45_localreg_95(l+((k-5)*5));
                    
                    CF_retrofit_45_localreg_100(l+((k-5)*5)) = Revenue_retrofit_45_localreg_100(l+((k-5)*5)) - ...
                        CAPEX_retrofit_45_localreg_100(l+((k-5)*5)) - OPEX_retrofit_45_localreg_100(l+((k-5)*5)) - VOYEX_retrofit_45_localreg_100(l+((k-5)*5));
                    
                    CF_sail_another_route_45_localreg(l+((k-5)*5)) = Revenue_sail_another_route_45_localreg(l+((k-5)*5)) - ...
                        CAPEX_sail_another_route_45_localreg(l+((k-5)*5)) - OPEX_sail_another_route_45_localreg(l+((k-5)*5)) - VOYEX_sail_another_route_45_localreg(l+((k-5)*5));
                    
                    CF_sell_45_localreg(l+((k-5)*5)) = Revenue_sell_45_localreg(l+((k-5)*5)) - ...
                        CAPEX_sell_45_localreg(l+((k-5)*5)) - OPEX_sell_45_localreg(l+((k-5)*5)) - VOYEX_sell_45_localreg(l+((k-5)*5));   
                end
           end
                
                % NPV from year 5-30: Retrofit, sail another route or sell.
                NPV_retrofit_45_localreg_95 = NPV(CF_retrofit_45_localreg_95,d_r,10);
                NPV_retrofit_45_localreg_100 = NPV(CF_retrofit_45_localreg_100,d_r,10);
                
                % If no global regualtions are introduced. 
                if Era_generation(6,19,Era) == 0 && Era_generation(6,21,Era) == 0
                    NPV_sail_another_route_45_localreg = NPV(CF_sail_another_route_45_localreg,d_r,10); % No retrofits, just sailing another route the whole time.  
                else
                    NPV_sail_another_route_45_localreg = 0;
                end
                
                NPV_sell_45_localreg = NPV(CF_sell_45_localreg,d_r,10);
                
                % NPV from year 5-30: Sail another route including global regulations at a later point in time. 
                NPV_sail_another_route_localreg_45_globalreg_56 = NPV(CF_sail_another_route_localreg_45_globalreg_56,d_r,10);
                
                % Optional retrofit for zero-emission compliance. 
                NPV_retrofit_56_optional = NPV(CF_retrofit_56_optional,d_r,10);
                
                % Collecting the 11 NPV values into one vector: 
                NPV_vector = [NPV_retrofit_45_localreg_95 NPV_retrofit_45_localreg_100 NPV_sail_another_route_45_localreg ...
                    NPV_sell_45_localreg NPV_sail_another_route_localreg_45_globalreg_56 NPV_retrofit_56_optional];
                
                % Select the one that maximises the NPV value for the rest
                % of the lifetime of the ship. 
                if max(NPV_vector) == NPV_vector(1)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:20)) CF_retrofit_45_localreg_95];
                    
                elseif max(NPV_vector) == NPV_vector(2)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:20)) CF_retrofit_45_localreg_100];
                    
                elseif max(NPV_vector) == NPV_vector(3)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:20)) CF_sail_another_route_45_localreg];
                    
                elseif max(NPV_vector) == NPV_vector(4)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:20)) CF_sell_45_localreg];
                    
                elseif max(NPV_vector) == NPV_vector(5)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:20)) CF_sail_another_route_localreg_45_globalreg_56];
                    
                elseif max(NPV_vector) == NPV_vector(6)    
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:20)) CF_retrofit_56_optional];
               
                end
               finishNow = true;         
        end

        % Terminates the inner for-loop
        if finishNow 
        break
        end
    
    % Terminates the outer for-loop
    if finishNow
    break
    end
        
    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Epoch 5 -> 6
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        % Check for global zero-emission regulation
        % Check if global zero-emission regulation occurs between epoch 5-6.
        
        if (Era_generation(i,19,Era) == 1 && i == 6 && j == 1) || (Era_generation(i,21,Era) == 1 && i == 6 && j == 1)
            
            for k = 6:6
                for l = 1:5
            
                    % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!) 
                    % The fuels are here assumed as drop-in fuelsNo CAPEX cost for retrofit is assumed,
                    if Era_generation(k,19,Era) == 1 && k == 6 && l == 1
                        Retrofit = 1;
                        Shipyard = 1;
                        CAPEX_retrofit_56_globalreg_95(l+((k-6)*5)) = CAPEX_retrofit_ammonia + CAPEX(k,l,Ship_design);
                        OPEX_retrofit_56_globalreg_95(l+((k-6)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_56_globalreg_95(l+((k-6)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_56_globalreg_95(l+((k-6)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    elseif Era_generation(k,19,Era) == 1
                        Retrofit = 1;
                        CAPEX_retrofit_56_globalreg_95(l+((k-6)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_56_globalreg_95(l+((k-6)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_56_globalreg_95(l+((k-6)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_56_globalreg_95(l+((k-6)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    
                    % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future local emissions zones also!)
                    if k == 6 && l == 1  
                        Retrofit = 2;
                        Shipyard = 1;
                        CAPEX_retrofit_56_globalreg_100(l+((k-6)*5)) = CAPEX_retrofit_hydrogen + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_56_globalreg_100(l+((k-6)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_56_globalreg_100(l+((k-6)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_56_globalreg_100(l+((k-6)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    else
                        Retrofit = 2;
                        Hydrogen = 1;
                        CAPEX_retrofit_56_globalreg_100(l+((k-6)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_56_globalreg_100(l+((k-6)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_56_globalreg_100(l+((k-6)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_56_globalreg_100(l+((k-6)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    

                    % Sell option: 
                    if k == 6 && l == 1
                        Retrofit = 0;
                        CAPEX_sell_56_globalreg(l+((k-6)*5)) = 0; 
                        OPEX_sell_56_globalreg(l+((k-6)*5)) = 0;
                        VOYEX_sell_56_globalreg(l+((k-6)*5)) = 0;
                        Revenue_sell_56_globalreg(l+((k-6)*5)) = Sell(k,Era,Era_generation,Ship_design) - Loan_balance(k,l,Ship_design);
                    else
                        Retrofit = 0;
                        CAPEX_sell_56_globalreg(l+((k-6)*5)) = 0; 
                        OPEX_sell_56_globalreg(l+((k-6)*5)) = 0;
                        VOYEX_sell_56_globalreg(l+((k-6)*5)) = 0;
                        Revenue_sell_56_globalreg(l+((k-6)*5)) = 0;    
                    end
            
                    CF_retrofit_56_globalreg_95(l+((k-6)*5)) = Revenue_retrofit_56_globalreg_95(l+((k-6)*5)) - ...
                        CAPEX_retrofit_56_globalreg_95(l+((k-6)*5)) - OPEX_retrofit_56_globalreg_95(l+((k-6)*5)) - VOYEX_retrofit_56_globalreg_95(l+((k-6)*5));
                    
                    CF_retrofit_56_globalreg_100(l+((k-6)*5)) = Revenue_retrofit_56_globalreg_100(l+((k-6)*5)) - ...
                        CAPEX_retrofit_56_globalreg_100(l+((k-6)*5)) - OPEX_retrofit_56_globalreg_100(l+((k-6)*5)) - VOYEX_retrofit_56_globalreg_100(l+((k-6)*5));
            
                    CF_sell_56_globalreg(l+((k-6)*5)) = Revenue_sell_56_globalreg(l+((k-6)*5)) - ...
                        CAPEX_sell_56_globalreg(l+((k-6)*5)) - OPEX_sell_56_globalreg(l+((k-6)*5)) - VOYEX_sell_56_globalreg(l+((k-6)*5));
            
                end
            end
            
            NPV_retrofit_56_globalreg_95 = NPV(CF_retrofit_56_globalreg_95,d_r,5);
            NPV_retrofit_56_globalreg_100 = NPV(CF_retrofit_56_globalreg_100,d_r,5);
            NPV_sell_56_globalreg = NPV(CF_sell_56_globalreg,d_r,5);
            
            if NPV_retrofit_56_globalreg_95 >= NPV_sell_56_globalreg && NPV_retrofit_56_globalreg_95 >= NPV_retrofit_56_globalreg_100
                
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:25)) CF_retrofit_56_globalreg_95];
                
            elseif NPV_retrofit_56_globalreg_100 >= NPV_sell_56_globalreg && NPV_retrofit_56_globalreg_100 >= NPV_retrofit_56_globalreg_95
                
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:25)) CF_retrofit_56_globalreg_100];     
                
            elseif NPV_sell_56_globalreg >= NPV_retrofit_56_globalreg_95 && NPV_sell_56_globalreg >= NPV_retrofit_56_globalreg_100
  
                Cash_flow_vector_end = [Cash_flow_vector(1,(1:25)) CF_sell_56_globalreg];
            
            end
            finishNow = true;
        end
        % Terminates the inner for-loop
        if finishNow 
        break
        end
    
    
    % Terminates the outer for-loop
    if finishNow
    break
    end
    
    
    
    % Check if local zero-emission regulation occurs between epoch 5-6.
        
        if (Era_generation(i,18,Era) == 1 && i == 6 && j == 1) || (Era_generation(i,20,Era) == 1 && i == 6 && j == 1)
            
           for k = 6:6
                for l = 1:5
            
                    % Retrofit option (95% zero emission): (A retrofitted cruise ship is assumed to comply with future 95% zero emission zones also!)
                    if Era_generation(i,18,Era) == 1 && k == 6 && l == 1
                        Retrofit = 1;
                        Shipyard = 1;
                        CAPEX_retrofit_56_localreg_95(l+((k-6)*5)) = CAPEX_retrofit_ammonia + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_56_localreg_95(l+((k-6)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_56_localreg_95(l+((k-6)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_56_localreg_95(l+((k-6)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    elseif Era_generation(i,18,Era) == 1
                        Retrofit = 1;
                        CAPEX_retrofit_56_localreg_95(l+((k-6)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_56_localreg_95(l+((k-6)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_56_localreg_95(l+((k-6)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_56_localreg_95(l+((k-6)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);   
                    end

                    % Retrofit option (100% zero emission): (A retrofitted cruise ship is assumed to comply with future 100% zero emission zones also!)
                    % Construction year:
                    if k == 6 && l == 1  
                        Retrofit = 2;
                        Shipyard = 1;
                        CAPEX_retrofit_56_localreg_100(l+((k-6)*5)) = CAPEX_retrofit_hydrogen + CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_56_localreg_100(l+((k-6)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_56_localreg_100(l+((k-6)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_56_localreg_100(l+((k-6)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    else
                        Retrofit = 2;
                        Hydrogen = 1;
                        CAPEX_retrofit_56_localreg_100(l+((k-6)*5)) = CAPEX(k,l,Ship_design); 
                        OPEX_retrofit_56_localreg_100(l+((k-6)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                        VOYEX_retrofit_56_localreg_100(l+((k-6)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                        Revenue_retrofit_56_localreg_100(l+((k-6)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard);
                    end
                    
                    % Sail another route option:
                    % Calculate for epoch 5,6 (depending on "global zero-emission" is introduced or not) 
                    Retrofit = 0;
                    CAPEX_sail_another_route_56_localreg(l+((k-6)*5)) = CAPEX(CAPEX_newbuild, t_loan_newbuild, i_r); 
                    OPEX_sail_another_route_56_localreg(l+((k-6)*5)) = OPEX(k,l,Ship_design,Retrofit,Hydrogen);
                    VOYEX_sail_another_route_56_localreg(l+((k-6)*5)) = VOYEX(k,l,Era,Retrofit,Ship_design,Era_generation,Stochastic_fuel_price,Stochastic_fuel_price_weekly,Shipyard,Revenue_time_loss); 
                    Revenue_sail_another_route_56_localreg(l+((k-6)*5)) = Revenue(k,l,Retrofit,Ship_design,Shipyard) - (Revenue(k,l,Retrofit,Ship_design,Shipyard)*Revenue_time_loss); % loss in revenue 
                    
                    % Sell option: 
                    if k == 6 && l == 1
                        Retrofit = 0;
                        CAPEX_sell_56_localreg(l+((k-6)*5)) = 0; 
                        OPEX_sell_56_localreg(l+((k-6)*5)) = 0;
                        VOYEX_sell_56_localreg(l+((k-6)*5)) = 0;
                        Revenue_sell_56_localreg(l+((k-6)*5)) = Sell(k,Era,Era_generation,Ship_design) - Loan_balance(k,l,Ship_design);
                    else
                        Retrofit = 0;
                        CAPEX_sell_56_localreg(l+((k-6)*5)) = 0; 
                        OPEX_sell_56_localreg(l+((k-6)*5)) = 0;
                        VOYEX_sell_56_localreg(l+((k-6)*5)) = 0;
                        Revenue_sell_56_localreg(l+((k-6)*5)) = 0;    
                    end
                    
                    
                    CF_retrofit_56_localreg_95(l+((k-6)*5)) = Revenue_retrofit_56_localreg_95(l+((k-6)*5)) - ...
                        CAPEX_retrofit_56_localreg_95(l+((k-6)*5)) - OPEX_retrofit_56_localreg_95(l+((k-6)*5)) - VOYEX_retrofit_56_localreg_95(l+((k-6)*5));
                    
                    CF_retrofit_56_localreg_100(l+((k-6)*5)) = Revenue_retrofit_56_localreg_100(l+((k-6)*5)) - ...
                        CAPEX_retrofit_56_localreg_100(l+((k-6)*5)) - OPEX_retrofit_56_localreg_100(l+((k-6)*5)) - VOYEX_retrofit_56_localreg_100(l+((k-6)*5));
                    
                    CF_sail_another_route_56_localreg(l+((k-6)*5)) = Revenue_sail_another_route_56_localreg(l+((k-6)*5)) - ...
                        CAPEX_sail_another_route_56_localreg(l+((k-6)*5)) - OPEX_sail_another_route_56_localreg(l+((k-6)*5)) - VOYEX_sail_another_route_56_localreg(l+((k-6)*5));
                    
                    CF_sell_56_localreg(l+((k-6)*5)) = Revenue_sell_56_localreg(l+((k-6)*5)) - ...
                        CAPEX_sell_56_localreg(l+((k-6)*5)) - OPEX_sell_56_localreg(l+((k-6)*5)) - VOYEX_sell_56_localreg(l+((k-6)*5));   
                end
           end
                
                % NPV from year 5-30: Retrofit, sail another route or sell.
                NPV_retrofit_56_localreg_95 = NPV(CF_retrofit_56_localreg_95,d_r,5);
                NPV_retrofit_56_localreg_100 = NPV(CF_retrofit_56_localreg_100,d_r,5);
                NPV_sail_another_route_56_localreg = NPV(CF_sail_another_route_56_localreg,d_r,5); % No retrofits, just sailing another route the whole time.  
                NPV_sell_56_localreg = NPV(CF_sell_56_localreg,d_r,5);
                
                NPV_vector = [NPV_retrofit_56_localreg_95 NPV_retrofit_56_localreg_100 NPV_sail_another_route_56_localreg NPV_sell_56_localreg];
                
                % Select the one that maximises the NPV value for the rest
                % of the lifetime of the ship. 
                if max(NPV_vector) == NPV_vector(1)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:25)) CF_retrofit_56_localreg_95];
                
                elseif max(NPV_vector) == NPV_vector(2)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:25)) CF_retrofit_56_localreg_100];
                    
                elseif max(NPV_vector) == NPV_vector(3)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:25)) CF_sail_another_route_56_localreg];
                    
                elseif max(NPV_vector) == NPV_vector(4)
                    Cash_flow_vector_end = [Cash_flow_vector(1,(1:25)) CF_sell_56_localreg];
                    
                end
               finishNow = true;         
        end

        % Terminates the inner for-loop
        if finishNow 
        break
        end
    
    % Terminates the outer for-loop
    if finishNow
    break
    end
        
    

        Cash_flow_vector(j+((i-1)*5)) = Revenue_vector(j+((i-1)*5)) - CAPEX_vector(j+((i-1)*5)) - OPEX_vector(j+((i-1)*5)) - VOYEX_vector(j+((i-1)*5));
    end
end


    % Check if regulations have been introduced. 
    if Era_generation(2,18,Era) == 0 && Era_generation(3,18,Era) == 0 && Era_generation(4,18,Era) == 0 && Era_generation(5,18,Era) == 0 && Era_generation(6,18,Era) == 0 ...
        && Era_generation(2,19,Era) == 0 && Era_generation(3,19,Era) == 0 && Era_generation(4,19,Era) == 0 && Era_generation(5,19,Era) == 0 && Era_generation(6,19,Era) == 0 ...
        && Era_generation(2,20,Era) == 0 && Era_generation(3,20,Era) == 0 && Era_generation(4,20,Era) == 0 && Era_generation(5,20,Era) == 0 && Era_generation(6,20,Era) == 0 ...
        && Era_generation(2,21,Era) == 0 && Era_generation(3,21,Era) == 0 && Era_generation(4,21,Era) == 0 && Era_generation(5,21,Era) == 0 && Era_generation(6,21,Era) == 0 

        Cash_flow_vector_total = [Construction_cost_vector Cash_flow_vector];
    else
        Cash_flow_vector_total = [Construction_cost_vector Cash_flow_vector_end];
    end

    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Including the sell value (book value) in the NPV calculation:
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % Reading from excel file to collecting the book values:
    Design_1 = xlsread('Annuity_loan.xls','Annuity loan (Design 1)');
    Design_2 = xlsread('Annuity_loan.xls','Annuity loan (Design 2)');
    Design_3 = xlsread('Annuity_loan.xls','Annuity loan (Design 3)');

    % Collecting the bookvalues.
    Book_value_ship_1 = Design_1(50,15);
    Book_value_ship_2 = Design_2(49,15);
    Book_value_ship_3 = Design_3(49,15);
    
    if Ship_design == 1
        Cash_flow_vector_total = [Cash_flow_vector_total(1,1:31) Cash_flow_vector_total(1,32)+Book_value_ship_1];
    elseif Ship_design == 2
        Cash_flow_vector_total = [Cash_flow_vector_total(1,1:31) Cash_flow_vector_total(1,32)+Book_value_ship_2];
    elseif Ship_design == 3
        Cash_flow_vector_total = [Cash_flow_vector_total(1,1:31) Cash_flow_vector_total(1,32)+Book_value_ship_3];
    end
    
% The resulting NPV for the baseline design:
CF = NPV(Cash_flow_vector_total,d_r,Total_lifecycle);

end
   

